#include "CBlast.h"

CBlast::CBlast()
{
	// 摜ǂݍ݂UVݒ
	m_Model[0].LoadImage( "pictures/blast.png", COLOR_XRGB(0,0,0) );
	m_Model[0].SetTextureRect( 0, 0, 128, 128 );

	m_Model[1].DuplicateImage( m_Model[0] );
	m_Model[1].SetScale( 0.5f, 0.5f );
}

void CBlast::Init()
{
	for ( int i = 0; i < MAX_BLASTS; i++ ) {
		m_BlastObjects[i].m_bActive = false;
	}
}

bool CBlast::Act()
{
	for ( int i = 0; i < MAX_BLASTS; i++ ) {
		BLAST_OBJECT *pObj = &m_BlastObjects[i];
		// ANeBuȂ
		if ( pObj->m_bActive ) {
			// [VԂ炷
			pObj->m_fMotionTime -= FTIME * 1000;
			if ( pObj->m_fMotionTime < 0 )	// ԂȂȂANeBu
				pObj->m_bActive = false;
		}
	}

	return true;
}

bool CBlast::Draw()
{
	for ( int i = 0; i < MAX_BLASTS; i++ ) {
		if ( m_BlastObjects[i].m_bActive ) {
			DrawObject( &m_BlastObjects[i] );
		}
	}

	return true;
}

bool CBlast::Add( float x, float y, float fMotionTime, float fScale, char type )
{
	int index = GetEmptyObjectIndex();
	if ( index < 0 ) return false;

	BLAST_OBJECT *pObj = &m_BlastObjects[index];
	pObj->m_bActive = true;
	pObj->m_Pos.x = x;
	pObj->m_Pos.y = y;
	pObj->m_fMotionTime = fMotionTime;
	pObj->m_fMotionColorValue = 255 / fMotionTime;
	pObj->m_fScale = fScale;
	pObj->m_fMotionScaleValue = 180 / fMotionTime;
	pObj->type = type;

	return true;
}

void CBlast::DrawObject( BLAST_OBJECT *pObj )
{
	if ( pObj->m_fMotionTime < 0 ) return;
	
	float fScale;	// OtBbN̑傫
	int color;		// ̐F

	fScale = (float) sin( D3DXToRadian(pObj->m_fMotionTime * pObj->m_fMotionScaleValue ) )
			 * pObj->m_fScale;
	color = pObj->m_fMotionTime * pObj->m_fMotionColorValue;

	char type = pObj->type;

	m_Model[type].SetColor( BLEND_ADD, COLOR_ARGB( color, color, color, color ) );
	m_Model[type].SetScale( fScale, fScale );
	m_Model[type].Draw( pObj->m_Pos.x, pObj->m_Pos.y );
}

int CBlast::GetEmptyObjectIndex()
{
	for ( int i = 0; i < MAX_BLASTS; i++ ) {
		if ( m_BlastObjects[i].m_bActive == false )
			return i;
	}

	return -1;
}