#include "CEnemies.h"

CEnemies::CEnemies()
{
	m_Models[0].LoadImage( "pictures/meteo.png" );
	m_Models[0].SetTextureRect( 0, 0, 42, 53 );
	m_Models[0].SetHitRect( 3, 5, 38, 38 );

	m_Models[1].DuplicateImage( m_Models[0] );
	m_Models[1].SetTextureRect( 44, 0, 24, 26 );
	m_Models[1].SetHitRect( 2, 2, 21, 21 );

	m_FireModels[0].LoadImage( "pictures/fire.png" );
	m_FireModels[0].SetColor( BLEND_NORMAL, COLOR_ARGB( 100, 100, 100, 100 ) );

	Init();
}

bool CEnemies::Init()
{
	for ( int i = 0; i < MAX_ENEMIES; i++ ) {
		m_EnemyObjects[i].m_bActive = false;
	}

	m_Score = 0;

	return true;
}

bool CEnemies::Act( CShip *pShip, CShots *pShots, CBlast *pBlast, CGameSound *pSound, CScore *pScore )
{
	for ( int i = 0; i < MAX_ENEMIES; i++ ) {
		ENEMY_OBJECT *pObj = &m_EnemyObjects[i];

		if ( pObj->m_bActive == false ) continue;

		// 覐΂̏ꍇ
		if( pObj->type == 1 ) {
			if ( pObj->m_Pos.y < -100 ) {
				pObj->m_Pos.y = 0;
				pObj->m_V.y *= -1;
			}
		}

		// ʏŁAɌĂ璵˕Ԃ
		if ( pObj->m_Pos.y < 0 && pObj->m_V.y < 0 ) pObj->m_V.y *= -1;
		// ʉɂ璵˕Ԃ
		if ( pObj->m_Pos.y > SCREEN_HEIGHT - 20 ) pObj->m_V.y *= -1;
		// ǂɓ璵˕Ԃ
		if ( pObj->m_Pos.x >= SCREEN_WIDTH || pObj->m_Pos.x <= 0) {
			pObj->m_V.x *= -1;
		}

		// G̈ړ
		pObj->m_Pos.y += FTIME * pObj->m_V.y;
		pObj->m_Pos.x += FTIME * pObj->m_V.x;
		pObj->m_fRotationAngle += pObj->m_RotateDir * FTIME * 100;

		bool bHit = false;
		// 蔻
		if ( pShots->HitCheck( pObj->m_Pos.x, pObj->m_Pos.y, 
				m_Models[pObj->type].GetHitRect(), SHOT_MACHINEGUN, true ) ) {
			bHit = true;
			pObj->m_cHP--;
		}

		else if ( pShots->HitCheck( pObj->m_Pos.x, pObj->m_Pos.y, 
				m_Models[pObj->type].GetHitRect(), SHOT_MISSILE, false ) ) {
			bHit = true;
			pObj->m_cHP -= 3;
		}

		if ( bHit ) {
			if ( pObj->m_cHP > 0 ) continue;
			
			pObj->m_bActive = false;

			// 覐΂A覐΂ɕ􂷂
			if ( pObj->type == 0 ) {
				for ( int i = 0; i < 3; i++ ) {
					int vx = 80 + rand() % 80;
					int vy = 80 + rand() % 80;
					int dirx = (rand() % 2) ? 1 : -1;
					int diry = (rand() % 2) ? 1 : -1;
					Add( pObj->m_Pos.x + dirx*vx/10, pObj->m_Pos.y + diry*vy/10, dirx * vx, diry * vy, 1 );
				}
				pBlast->Add( pObj->m_Pos.x, pObj->m_Pos.y, 500.0f, 3.0f, 0 );
				pSound->Add( SND_BLAST );
				pScore->AddScore( 2 );
			}
			else if ( pObj->type == 1 ) {
				pBlast->Add( pObj->m_Pos.x, pObj->m_Pos.y, 500.0f, 2.0f, 1 );
				pSound->Add( SND_BLAST2 );
				m_Score++;
				pScore->AddScore( 1 );
			}
		}
	}

	return true;
}

bool CEnemies::Draw()
{
	for ( int i = 0; i < MAX_ENEMIES; i++ ) {
		ENEMY_OBJECT *pObj = &m_EnemyObjects[i];

		if ( pObj->m_bActive ) {
			d3d.sprite.SetRotate( m_Models[pObj->type].GetSprobj(), 
					pObj->m_fRotationAngle, pObj->m_CentralPos.x, pObj->m_CentralPos.y );

			if ( pObj->type == 0 )
				m_FireModels[0].Draw( pObj->m_Pos.x - 40, pObj->m_Pos.y - 50 );
			m_Models[pObj->type].Draw( pObj->m_Pos.x, pObj->m_Pos.y );
		}
	}

	return true;
}

bool CEnemies::Add( float x, float y, float vx, float vy, char type )
{
	int index = GetEmptyObjectIndex();
	if ( index < 0 ) return false;

	ENEMY_OBJECT *pObj = &m_EnemyObjects[index];

	pObj->type = type;	// G̎ނ̐ݒ

	RECT rect = m_Models[type].GetTextureRect();
	pObj->m_CentralPos.x = rect.right / 2.0;
	pObj->m_CentralPos.y = rect.bottom / 2.0;

	pObj->m_bActive = true;	// gp

	// ʒuݒ
	pObj->m_Pos.x = x;
	pObj->m_Pos.y = y;
	//x̐ݒ
	pObj->m_V.x = vx;
	pObj->m_V.y = vy;

	pObj->m_fRotationAngle = 0;
	pObj->m_RotateDir = rand() % 2 ? 1 : -1;

	// qbg|Cg̏
	int hp = 0;
	switch ( type ) {
	case 0: hp = 1; break;
	case 1: hp = 1; break;
	}
	pObj->m_cHP = hp;

	pObj->m_iFrameCount = 0;


	return true;
}

bool CEnemies::HitCheck( float x, float y, RECT HitRect )
{
	for ( int i = 0; i < MAX_ENEMIES; i++ ) {
		ENEMY_OBJECT *pObj = &m_EnemyObjects[i];

		if ( pObj->m_bActive ) {
			bool bl = m_Models[pObj->type].HitCheck( pObj->m_Pos.x, pObj->m_Pos.y,
												     HitRect, x, y );
			if ( bl ) return true;
		}
	} 

	return false;
}

int CEnemies::GetEmptyObjectIndex()
{
	for ( int i = 0; i < MAX_ENEMIES; i++ ) {
		if ( m_EnemyObjects[i].m_bActive == false ) {
			return i;
		}
	}

	return -1;
}
