#include "CGameSound.h"

CGameSound::CGameSound()
{
	char *SoundName[] = {
		"sounds/Blast.wav", "sounds/Blast2.wav", "sounds/Meteo.wav",
		"sounds/MachineGun.wav", "sounds/Missile.wav"
	};

	m_MaxSoundType = sizeof( SoundName ) / sizeof( SoundName[0] );

	for ( int i = 0; i < m_MaxSoundType; i++ ) {
		sound.Create( m_SoundObjects[i][0].m_Sound, SoundName[i] );

		for ( int j = 1; j < MAX_ONE_SOUNDS; j++ ) {
			sound.Duplicate( m_SoundObjects[i][j].m_Sound, m_SoundObjects[i][0].m_Sound );
		}
	}

	Init();
	/*
	for ( int i = 0; i < max; i++ ) {
		sound.Create( m_OriginalSounds[i], SoundName[i] );
		for ( int j = 0; i < MAX_ONE_SOUNDS; i++ ) {
			sound.Duplicate( m_SoundObjects[i][j], m_OriginalSounds[i] );
		}
	}
	*/
}

void CGameSound::Init()
{
	for ( int i = 0; i < m_MaxSoundType; i++ ) {
		for ( int j = 0; j < MAX_ORIGINAL_SOUNDS; j++ )
			m_SoundObjects[i][j].m_bActive = false;
	}
}

bool CGameSound::Add( SOUND_TYPE type )
{
	int index = GetEmptyObjectIndex( type );
	if ( index < 0 ) return false;

	SOUND_OBJECT *pObj = &( m_SoundObjects[type][index] );

	pObj->m_bActive = true;
	pObj->type = type;
//	sound.Duplicate( m_SoundObjects[type][index].m_Sound,
//					 m_SoundObjects[type][0].m_Sound );

	return true;
}

bool CGameSound::Act()
{
	for ( int i = 0; i < m_MaxSoundType; i++ ) {
		for ( int j = 0; j < MAX_ORIGINAL_SOUNDS; j++ ) {
			if ( m_SoundObjects[i][j].m_bActive ) {
				sound.Play( m_SoundObjects[i][j].m_Sound );
				m_SoundObjects[i][j].m_bActive = false;
			}
		}
	}

	return true;
}

int CGameSound::GetEmptyObjectIndex( SOUND_TYPE type )
{
	for ( int i = 0; i < MAX_ONE_SOUNDS; i++ ) {
		if ( m_SoundObjects[type][i].m_bActive == false ) {
			if ( sound.IsPlaying( m_SoundObjects[type][i].m_Sound ) == false )
				return i;
		}
	}
	
	return -1;
}