#include "CModel.h"

CModel::CModel()
{
	SetRect( &m_HitRect, 0, 0, 0, 0 );
}

bool CModel::Draw( float x, float y, float z )
{
	if ( !d3d.sprite.Draw( m_Sprobj, x, y, z ) )
		return false;

	return true;
}

bool CModel::LoadImage( char *filename, D3DCOLOR color )
{
	if ( !d3d.sprite.Create( m_Sprobj, filename, color ) )
		return false;

	return true;
}

bool CModel::DuplicateImage( CModel model )
{
	if ( m_Sprobj == model.GetSprobj() ) return true;

	if ( !d3d.sprite.Duplicate( m_Sprobj, model.GetSprobj() ) )
		return false;

	RECT rect = model.GetHitRect();
	SetHitRect( rect.left, rect.top, rect.right, rect.bottom );

	return true;
}

bool CModel::SetTextureRect( int x, int y, int sizex, int sizey )
{
	if ( !d3d.sprite.SetTextureRect( m_Sprobj, x, y, sizex, sizey ) )
		return false;

	return true;
}

void CModel::SetHitRect( int x, int y, int x2, int y2 )
{
	SetRect( &m_HitRect, x, y, x2, y2 );
}

bool CModel::HitCheck( float px, float py, RECT HitRect, float px2, float py2 )
{
	RECT rc, rc2;
	SetRect( &rc, m_HitRect.left + px, m_HitRect.top + py, 
			 m_HitRect.right + px, m_HitRect.bottom + py );

	rc2 = HitRect;
	rc2.left += px2;
	rc2.top += py2;
	rc2.right += px2;
	rc2.bottom += py2;

	if ( rc.left <= rc2.right && rc.right >= rc2.left && 
		 rc.top <= rc2.bottom && rc.bottom >= rc2.top ) {
		return true;
	}

	return false;
}

bool CModel::SetColor( BLEND_MODE mode, D3DXCOLOR color )
{
	if ( !d3d.sprite.SetBlendColor( m_Sprobj, mode, color ) )
		return false;

	return true;
}

bool CModel::SetScale( float sx, float sy )
{
	RECT rect;
	d3d.sprite.GetTextureRect( m_Sprobj, rect );

	if ( !d3d.sprite.SetScale( m_Sprobj, sx, sy, rect.right / 2.0f, rect.bottom / 2.0f ) ) {
		return false;
	}

	return true;
}

RECT CModel::GetTextureRect()
{
	RECT rect;
	d3d.sprite.GetTextureRect( m_Sprobj, rect );
	return rect;
}

