#include "CShots.h"

#define SHOT_SPEED (-300)

CShots::CShots()
{
	m_Models[0].LoadImage( "pictures/weapon.png" );
	m_Models[0].SetTextureRect( 0, 0, 32, 32 );
	m_Models[0].SetHitRect( 10, 2, 20, 28 );

	m_Models[1].DuplicateImage( m_Models[0] );
	m_Models[1].SetTextureRect( 32, 0, 32, 32 );
	m_Models[1].SetHitRect( 10, 0, 20, 32 );

	Init();
}

bool CShots::Init()
{
	for ( int i = 0; i < MAX_SHOTS; i++ ) {
		m_ShotObjects[i].m_bActive = false;
	}

	return true;
}

bool CShots::Act()
{
	for ( int i = 0; i < MAX_SHOTS; i++ ) {
		if ( m_ShotObjects[i].m_bActive ) {
			// ʊOɂł
			if ( m_ShotObjects[i].m_Pos.y < -100 )
				m_ShotObjects[i].m_bActive = false;

			m_ShotObjects[i].m_Pos.x += m_ShotObjects[i].m_Speed.x * FTIME;
			m_ShotObjects[i].m_Pos.y += m_ShotObjects[i].m_Speed.y * FTIME;
		}
	}

	return true;
}

bool CShots::Draw()
{
	for ( int i = 0; i < MAX_SHOTS; i++ ) {
		SHOT_OBJECT *pObj = &m_ShotObjects[i];

		if ( pObj->m_bActive ) {
			m_Models[ pObj->type ].Draw( pObj->m_Pos.x, pObj->m_Pos.y );
		}
	}

	return true;
}

bool CShots::Add( float x, float y, float vx, float vy, SHOT_TYPE type )
{
	int index = GetEmptyObjectIndex();
	if ( index < 0 ) return false;
	
	m_ShotObjects[index].m_bActive = true;
	m_ShotObjects[index].m_Pos.x = x;
	m_ShotObjects[index].m_Pos.y = y;

	m_ShotObjects[index].m_Speed.x = vx;
	m_ShotObjects[index].m_Speed.y = vy;

	m_ShotObjects[index].type = type;

	return true;
}

bool CShots::AddPlayerShot( float x, float y )
{	
	return Add( x, y, 0, SHOT_SPEED, SHOT_MACHINEGUN );
}

bool CShots::AddPlayerShot2( float x, float y )
{
	return Add( x, y, 0, SHOT_SPEED, SHOT_MISSILE );
}

bool CShots::AddEnemyNormalShot( float x, float y, D3DXVECTOR2 vTargetPos )
{
	return true;
}

bool CShots::HitCheck( float x, float y, RECT HitRect, SHOT_TYPE ShotType, bool bEraseShot )
{
	for	( int i = 0; i < MAX_SHOTS; i++ ) {
		SHOT_OBJECT *pObj = &m_ShotObjects[i];

		if ( pObj->m_bActive ) {
			if ( pObj->type != ShotType )
				continue;

			bool bl = m_Models[ShotType].HitCheck( pObj->m_Pos.x, pObj->m_Pos.y, 
													   HitRect, x, y );
			if ( bl ) {
				if ( bEraseShot )
					pObj->m_bActive = false;
				return true;
			}
		}
	}

	return false;
}

int CShots::GetEmptyObjectIndex()
{
	for ( int i = 0; i < MAX_SHOTS; i++ ) {
		if ( m_ShotObjects[i].m_bActive == false ) 
			return i;
	}

	return -1;
}