#ifndef _APP_SYSTEM_H_
#define _APP_SYSTEM_H_

#pragma warning( disable: 4786 )

//-----------------------------------------------------------------------------
// Static Library
//-----------------------------------------------------------------------------
#pragma comment( lib, "shlwapi.lib" )

#pragma comment( lib, "DxApp/Lib/vorbis_static.lib" )
#pragma comment( lib, "DxApp/Lib/ogg_static.lib" )
#pragma comment( lib, "DxApp/Lib/vorbisfile_static.lib" )

#pragma comment( lib, "DxApp/Lib/AppDebug.lib" )

//-----------------------------------------------------------------------------
// Header
//-----------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <mbstring.h>	//_mbsnextc, _mbsincp
#include <mmsystem.h>
#include <vector>
#include <string>
#include <d3dx9core.h>
#include <d3dx9.h>
#include <dxerr9.h>
#include <dinput.h>
#include <basetsd.h>
#include <dsound.h>
#include <Shlwapi.h>

#include "AppDebug.h"

//-----------------------------------------------------------------------------
// }N
//-----------------------------------------------------------------------------

// DirectX IuWFNg̊J
#define RELEASE(x)	if (x) { x->Release(); x = NULL; }

// mۂAŌNULL
#define SAFE_DELETE(x) if (x) { delete x; x = NULL; }

// zZ[tf[g
#define SAFE_DELETE_ARRAY(x) if (x) { delete [] x; x = NULL; }

// J
#define SAFE_FREE(x) if (x) { free(x); x = NULL; }

// floatɕϊ
#define F(x) (float) (x)

// 2D \p}N
#define D3DFVF_2DVERTEX ( D3DFVF_XYZRHW | D3DFVF_DIFFUSE | \
						 D3DFVF_SPECULAR | D3DFVF_TEX1 )

// 3D \p}N
#define D3DFVF_3DVERTEX ( D3DFVF_XYZ | D3DFVF_DIFFUSE | \
						 D3DFVF_SPECULAR | D3DFVF_TEX1 )

// DirectX J[
#define COLOR_XRGB( r, g, b )		D3DCOLOR_XRGB( r, g, b )
#define COLOR_ARGB( a, r, g, b )	D3DCOLOR_ARGB( a, r, g, b )
#define COLOR_RGBA( r, g, b, a )	D3DCOLOR_RGBA( r, g, b, a )

// FrameTime
#define FTIME app.fps.GetFrameTime()

// FPS
#define FPS app.fps.GetFPS()

//-----------------------------------------------------------------------------
// \
//-----------------------------------------------------------------------------

// 3DIuWFNg\
struct D3DTLVERTEX {
	float	x, y, z;	// ʒu				
	float	rhw;															 
	DWORD	color;		// _Fiqfa`j
	DWORD	specular;	// XyLF
	float	tu, tv;		// eNX`W
};

// 3DIuWFNg\
struct D3DLVERTEX {
	float	x, y, z;	// ʒu																		 
	DWORD	color;		// _Fiqfa`j
	DWORD	specular;	// XyLF
	float	tu, tv;		// eNX`W
};

// D3DXMATRIX_DATA \
struct D3DXMATRIX_INFO {
	D3DXVECTOR3 Rotate;		// ]
	D3DXVECTOR3 Translate;	// sړ
	D3DXVECTOR3 Scale;		// XP[
	D3DXMATRIX_INFO() { 
		Rotate	  = D3DXVECTOR3( 0, 0, 0 );
		Translate = D3DXVECTOR3( 0, 0, 0 );
		Scale	  = D3DXVECTOR3( 1, 1, 1 );
	}
};

// BOOL2 \
struct BOOL2 {
	bool x;
	bool y;
	BOOL2() { x = 0; y = 0; }
	BOOL2( bool x, bool y ) { this->x = x; this->y = y; }
};

// BLEND_MODE 񋓑
enum BLEND_MODE {
	BLEND_NORMAL,	// ʏAt@uh
	BLEND_ADD		// ZAt@uh
};

// PRIMITIVE_TYPE 񋓑
enum PRIMITIVE_TYPE
{
	PRIMITIVE_FLAT
};

//-----------------------------------------------------------------------------
// ֐
//-----------------------------------------------------------------------------

// D3DTLVERTEX \̂̒lݒ
inline void SetD3DTLVERTEX( D3DTLVERTEX &vertex, float x, float y, float z, 
					 float rhw, DWORD color, DWORD specular, float tu, float tv )
{
	vertex.x = x;
	vertex.y = y;
	vertex.z = z;
	vertex.rhw = rhw;
	vertex.color = color;
	vertex.specular = specular;
	vertex.tu = tu;
	vertex.tv = tv;
}

// t@CEpXt@C폜
inline void RemoveFileName( char *ch )
{
	int n = 0;
	for ( int i = 0; i < ( signed ) strlen( ch ); i++ ) {
		if ( ch[i] == '/' || ch[i] == '\\' ) {
			n = i;
			break;
		}
	}
	ch[n] = '\0';
}

// D3DXVECTOR3̋߂
inline void GetD3DXVector3Distance( float &distance, D3DXVECTOR3 vec, D3DXVECTOR3 vec2 )
{
	distance = sqrt( pow( vec.x - vec2.x, 2 ) +
				     pow( vec.y - vec2.y, 2 ) +
				     pow( vec.z - vec2.z, 2 ) );
}

//-----------------------------------------------------------------------------
// Include
//-----------------------------------------------------------------------------

// VXe
#include "ObjectArray.h"

// TEh NX
#include "oggvorbis/codec.h"
#include "oggvorbis/vorbisfile.h"
#include "soundreader.h"
#include "sound.h"

//  NX
#include "mouse.h"
#include "key.h"
#include "input.h"

// ` NX
#include "texture.h"
#include "line2d.h"
#include "camera.h"
#include "font.h"
#include "sprite.h"
#include "dxsprite.h"
#include "xfile.h"
#include "light.h"
#include "d3d.h"

// AvP[VENX
#include "fps.h"
#include "app.h"

#endif