#ifndef _CCAMERA_H_
#define _CCAMERA_H_

//-----------------------------------------------------------------------------
// Name : CCamera NX
// Desc : Js
//-----------------------------------------------------------------------------
class CCamera
{
private:
	D3DXVECTOR3	m_EyePos;			// _
	D3DXVECTOR3 m_LookPos;		// _
	D3DXVECTOR3 m_UpVector;	// J̌

	float		m_fViewAngle;	// p
	float		m_fAspectRatio;	// AXyNg
	float		m_fViewMin;		// Oe
	float		m_fViewMax;		// e

	D3DXMATRIX	m_mView, m_mProjection;

public:
	CCamera();
	~CCamera();

	void Init();	// 
	void SetEyePos( float x, float y, float z );			// _̐ݒ
	void SetLookPos( float x, float y, float z );		// _̐ݒ
	void SetUpVector( float x, float y, float z );		// xNg̐ݒ
	void SetViewAngle( int n );							// p̐ݒ
	void SetAspectRatio( float n );						// AXyNg̐ݒ
	void SetViewArea( float min, float max );			// eʂ̐ݒ

	void SetTransform();

	const D3DXMATRIX* GetpViewMatrix();
	const D3DXMATRIX* GetpProjectionMatrix();
};

#endif