#ifndef _CDXSPRITE_H_
#define _CDXSPRITE_H_

//-----------------------------------------------------------------------------
// Name : DXSPROBJ \
//-----------------------------------------------------------------------------
struct DXSPROBJ : public STDOBJ {
};

//-----------------------------------------------------------------------------
// Name : SPRITE_INFO \
//-----------------------------------------------------------------------------
struct DXSPRITE_INFO {
	float		angle;				// XvCg]px
	D3DXVECTOR2	RotationCenter;		// XvCg]AgkS
	D3DXVECTOR2 scale;				// XvCgXP[
	D3DXVECTOR2 ScalingCenter;		// XP[sS_
	DWORD		color;				// XvCgqfa`
	BLEND_MODE	blend;				// XvCguh[h
	RECT		rect;				// eNX`ETCY
	TEXOBJ		TexObj;				// eNX`EIuWFNg

	DXSPRITE_INFO();
	~DXSPRITE_INFO();
};

//-----------------------------------------------------------------------------
// Name : CDXSpriteManager
// Desc : XvCgs
//-----------------------------------------------------------------------------
class CDXSpriteManager
{
private:
	LPD3DXSPRITE m_pSprite;
	CObjectArray<DXSPRITE_INFO> m_vInfo;
	
public:
	CDXSpriteManager();
	~CDXSpriteManager();

	bool Init();			// 
	bool OnLostDevice();	// foCX̏
	bool OnResetDevice();	// foCX̕
	bool GetpSprite( LPD3DXSPRITE *ppSprite );	// XvCg̎擾

	bool Begin();			// `Jn
	bool End();				// `I

	// XvCg̍쐬 ( t@C )
	bool Create( DXSPROBJ &obj, char *filename,	D3DCOLOR ColorKey = 0 );
	// XvCg̍쐬 ( eNX` )
	bool Create( DXSPROBJ &obj, TEXOBJ tobj );
	// XvCg̕
	bool Duplicate( DXSPROBJ &DestObj, DXSPROBJ SourceObj );
	// XvCg̍폜
	bool Delete( DXSPROBJ &obj );
	// XvCg̕\
	bool Draw( DXSPROBJ obj, float x, float y, float z = 0 );		

	// XvCg̊px̐ݒ
	bool SetRotate( DXSPROBJ obj, float angle, float cx, float cy );
	// XvCg̃XP[̐ݒ
	bool SetScale( DXSPROBJ obj, float sx, float sy, float cx, float cy );
	// XvCg̃uhF̐ݒ
	bool SetBlendColor( DXSPROBJ obj, BLEND_MODE mode, D3DCOLOR color );
	// XvCg̕\̈̐ݒ
	bool SetTextureRect( DXSPROBJ obj, int left, int top, int right, int bottom );
};

#endif