#ifndef _CLINE_H_
#define _CLINE_H_

//-----------------------------------------------------------------------------
// Name : struct LINE_BASE_OBJ
//-----------------------------------------------------------------------------
struct BASE_LINEOBJ : public STDOBJ {
};

//-----------------------------------------------------------------------------
// Name : struct LINE2DOBJ
//-----------------------------------------------------------------------------
struct LINE2DOBJ : public BASE_LINEOBJ {
};

//-----------------------------------------------------------------------------
// Name : struct LINE3DOBJ
//-----------------------------------------------------------------------------
struct LINE3DOBJ : public BASE_LINEOBJ {
};

//-----------------------------------------------------------------------------
// Name : struct LINE_INFO
//-----------------------------------------------------------------------------
struct LINE_INFO {
	std::vector< D3DXVECTOR3 > v3DVertex;
	std::vector< D3DXVECTOR2 > v2DVertex;
	TEXOBJ		TexObj;
	D3DCOLOR	Color;
	float		fWidth;
	bool		bAntialias;
	DWORD		dwPattern;
	bool		bGLLines;
	float		fScale;

	LINE_INFO();
	~LINE_INFO();
};

//-----------------------------------------------------------------------------
// Name : class CLine 
// Desc : C̕`
//-----------------------------------------------------------------------------
class CLine
{
	CObjectArray< LINE_INFO > m_vInfo;
	LPD3DXLINE m_pLine;

public:
	CLine();
	~CLine();	
	void OnLostDevice();
	void OnResetDevice();
	bool Init();

	bool Create( BASE_LINEOBJ &obj );	// 쐬
	bool Delete( BASE_LINEOBJ &obj );	// 폜
	bool Draw3D( LINE3DOBJ obj );		// `
	bool Draw2D( LINE2DOBJ obj );

	bool SetTexture( BASE_LINEOBJ obj, const char *filename );
	bool SetVertex3D( LINE3DOBJ obj, D3DXVECTOR3 vector );
	bool SetVertex2D( LINE2DOBJ obj, D3DXVECTOR2 vector );
	bool Delete3DVertex( LINE3DOBJ obj, int n );
	bool Delete2DVertex( LINE2DOBJ obj, int n );
	bool ClearVertex( BASE_LINEOBJ &obj );

	bool SetColor( BASE_LINEOBJ obj, D3DCOLOR color );
	bool SetWidth( BASE_LINEOBJ obj, float fWidth );
	bool SetAntialias( BASE_LINEOBJ obj, bool bl );
	bool SetPattern( BASE_LINEOBJ obj, DWORD dwPattern );
	bool SetGLLines( BASE_LINEOBJ obj, bool bl );
	bool SetPatternScale( BASE_LINEOBJ obj, float fScale );

	const LINE_INFO* GetpLineInfo( BASE_LINEOBJ obj );
};

#endif