#ifndef _CSOUND_H_
#define _CSOUND_H_

//-----------------------------------------------------------------------------
// Name : SOUND_OBJ \
//-----------------------------------------------------------------------------
struct SNDOBJ : public STDOBJ {
};

//-----------------------------------------------------------------------------
// Name : SOUND_INFO \
//-----------------------------------------------------------------------------
struct SOUND_INFO {
	LPDIRECTSOUNDBUFFER8	pDSoundBuffer;
	LPDIRECTSOUND3DBUFFER8	pDSound3DBuffer;
	SOUND_INFO();
	~SOUND_INFO();
};

//-----------------------------------------------------------------------------
// Name : CDSoundManager NX
// Desc : TEh֘Ȁs
//-----------------------------------------------------------------------------
class CDSoundManager
{
private:
	LPDIRECTSOUND8				m_pDSound;
	LPDIRECTSOUND3DLISTENER8	m_pListener;

	CObjectArray<SOUND_INFO> m_vInfo;

	bool CopyMem( LPDIRECTSOUNDBUFFER8 pSoundBuffer, DWORD *pWaveData, 
			DWORD WaveSize );
	// TEh̍쐬( 2D or 3D )
	bool CreateSound( SNDOBJ &obj, char *filename, bool b3D );
	bool SetDSBufferDesc( DSBUFFERDESC &dsbd, DWORD dwBufferBytes, 
						  WAVEFORMATEX *pdwFormat, bool bSound3D = false );

public:
	CDSoundManager();
	~CDSoundManager();

	SOUND_INFO *GetpSoundInfo( SNDOBJ obj );

	bool Init( HWND hWnd );							// 
	
	bool Create( SNDOBJ &obj, char *filename );		// TEh̍쐬
	bool Create3D( SNDOBJ &obj, char *filename );	// 3DTEh̍쐬
	bool Delete( SNDOBJ &obj );						// TEh̍폜
	bool Duplicate( SNDOBJ &obj1, SNDOBJ obj2, bool bSound3D = false );	// TEh̕

	bool Play( SNDOBJ obj, bool loop = false );	// TEh̍Đ
	bool Stop( SNDOBJ obj );					// TEh̒~
	void StopAll();								// ׂẴTEh̒~
	bool Pause( SNDOBJ obj );					// TEḧꎞ~
	bool IsPlaying( SNDOBJ &obj, bool IsLoop = false );	// TEh̍ĐԂ̎擾

	bool SetVolume( SNDOBJ obj, int volume );			// {[̐ݒ
	bool SetFrequency( SNDOBJ obj, int Frequency = 0 );	// g̐ݒ
	bool GetFrequency( SNDOBJ obj, int &rFrequency );	// g̎擾

	bool SetPan( SNDOBJ obj, int pan );					// p̐ݒ

	bool SetPos( SNDOBJ obj, float x, float y, float z );		// ʒu̐ݒ
	bool SetVelocity( SNDOBJ obj, float x, float y, float z );	// x̐ݒ
	bool SetMinDistance( SNDOBJ obj, float min );	// ŏ̐ݒ
	bool SetMaxDistance( SNDOBJ obj, float max );	// ő勗̐ݒ

	// 3DTEh̃R[px̐ݒ
	bool SetConeAngle( SNDOBJ obj, int inAngle, int outAngle );		
	// 3DTEh̃R[̐ݒ
	bool SetConeDirection( SNDOBJ obj, float x, float y, float z );	
	// 3DTEh̃R[Oʂ̐ݒ
	bool SetConeOutsideVolume( SNDOBJ obj, int volume );				
};

extern CDSoundManager sound;

#endif