#ifndef _CXFILE_H_
#define _CXFILE_H_

#include <string>

//-----------------------------------------------------------------------------
// Name : XFOBJ \
//-----------------------------------------------------------------------------
struct XFOBJ : public STDOBJ {
};

//-----------------------------------------------------------------------------
// Name : XFILE_DATA \
//-----------------------------------------------------------------------------
struct XFILE_DATA
{
	int	nRef;	// QƃJE^

	LPD3DXMESH			pD3DMesh;		// wt@C[hpbV
	LPDIRECT3DTEXTURE9* pTextures;		// eNX`obt@
	D3DMATERIAL9*		pD3DMaterial;	// }eAobt@
	DWORD				dwMaterialNum;	// }eA
	LPD3DXBUFFER		pD3DBuffer;		// }eA

	XFILE_DATA();

	int AddRef();		// QƃJE^𑝂₷
	void Release();		// IuWFNgJ
};

//-----------------------------------------------------------------------------
// Name : XFILE_INFO \
//-----------------------------------------------------------------------------
struct XFILE_INFO
{
	XFILE_DATA		*pData;
	D3DXMATRIX_INFO	Info;
	std::string     strFileName;

	XFILE_INFO();
	~XFILE_INFO();
};

//-----------------------------------------------------------------------------
// Name : CXFileManager NX
// Desc : XFile ֌W̏s
//-----------------------------------------------------------------------------
class CXFileManager
{
private:
	CObjectArray< XFILE_INFO > m_vInfo;

public:
	// XFile ̍쐬
	bool Create( XFOBJ &obj, const char* filename );
	// XFile ̕
	bool Duplicate( XFOBJ &dest, XFOBJ source );
	// XFile ̍폜
	bool Delete( XFOBJ &obj );	
	
	// XFile ̕`
	bool Draw( XFOBJ obj );

	// XFile ̉]px̐ݒ
	bool SetRotate( XFOBJ obj, float x, float y, float z );
	// XFile ̕sړ̐ݒ
	bool SetTranslate( XFOBJ obj, float x, float y, float z );
	// XFile ̃XP[̐ݒ
	bool SetScale( XFOBJ obj, float x, float y, float z );
	// ]px̎擾
	bool GetRotate( XFOBJ obj, D3DXVECTOR3 &vec );
	// sړ̎擾
	bool GetTranslate( XFOBJ obj, D3DXVECTOR3 &vec );
	// XP[̎擾
	bool GetScale( XFOBJ obj, D3DXVECTOR3 &vec );

	bool SetAmbientColor( XFOBJ obj, D3DCOLOR color );
	bool SetDeffuseColor( XFOBJ obj, D3DCOLOR color );
	bool SetTexture( XFOBJ obj, char *filename );

	bool RayHit( XFOBJ obj, D3DXVECTOR3 RayPos, D3DXVECTOR3 RayDir, 
		bool *pHit, DWORD *pFaceIndex, float *pU, float *pV, float *pDist );

	XFILE_INFO* GetpXFileInfo( XFOBJ obj );
	const char* GetpFileName( XFOBJ obj );
};

#endif