#include "../Include/AppSystem.h"
/*
// 
void Init();
// C
void Main( HWND hWnd );
// EBhEEvV[W
void MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
*/

//-----------------------------------------------------------------------------
// Name : WndProc()
// Desc : EBhEEvV[W
//-----------------------------------------------------------------------------
LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	app.MsgProc( hWnd, msg, wParam, lParam );

	RECT rect;

    switch( msg ) {
        case WM_DESTROY:
			PostQuitMessage( 0 );
			return 0;

		case WM_MOVE:
			GetWindowRect( hWnd, &rect );
			app.SetWindowPos( rect.left, rect.top );
			return 0;

		case WM_SIZE:
			GetClientRect( hWnd, &rect );
			app.SetClientSize( rect.right - rect.left, rect.bottom - rect.top );
			app.ResizeWindow();
			return 0;

		case WM_MOUSEMOVE:
			input.mouse.SetPos( LOWORD( lParam ), HIWORD( lParam ) );
			return 0;

		case WM_ACTIVATEAPP:
			if ( LOWORD( wParam ) != WA_INACTIVE ) {
				input.Restore();
			}
			return 0;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}

//-----------------------------------------------------------------------------
// Name : WinMain()
// Desc : C֐
//-----------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, 
				    LPSTR lpCmdLine, int nCmdShow )
{
	app.Init();

	// EBhE̍쐬
	if ( !app.Create( hInstance ) ) return 0;

	// EBhE̕\
	app.Show();

	// vÕC
	HWND hWnd;
	app.GethWnd( hWnd );

	// D3D ̏
	if ( !d3d.InitD3DObject() ) return 0;

	// Sound ̏
	if ( !sound.Init( hWnd ) ) return 0;

	// Input ̏
	if ( !input.Init( hWnd, hInstance ) ) return 0;

	app.Main( hWnd );

	return 0;
}

