#include "../Include/AppSystem.h"

//-----------------------------------------------------------------------------
// Name : CCamera()
//-----------------------------------------------------------------------------
CCamera::CCamera()
{
}

//-----------------------------------------------------------------------------
// Name : ~CCamera()
//-----------------------------------------------------------------------------
CCamera::~CCamera()
{
}

//-----------------------------------------------------------------------------
// Name : Init()
//-----------------------------------------------------------------------------
void CCamera::Init()
{
	m_fViewAngle	= D3DXToRadian( 45.0f );
	m_fViewMin		= 0.1f;
	m_fViewMax		= 1000.0f;
	m_EyePos			= D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	m_LookPos		= D3DXVECTOR3( 0.0f, 0.0f, 1.0f );
	m_UpVector	= D3DXVECTOR3( 0.0f, 1.0f, 1.0f );
	SIZE size		= { d3d.m_d3dpp.BackBufferWidth,
						d3d.m_d3dpp.BackBufferHeight };
	m_fAspectRatio	= (float) ( 1.0 * size.cx / size.cy );
}

//-----------------------------------------------------------------------------
// Name : SetEyePos()
// Desc : _̐ݒ
// Argu : x = wW
//		  y = xW
//		  z = yW
//-----------------------------------------------------------------------------
void CCamera::SetEyePos( float x, float y, float z )
{
	m_EyePos = D3DXVECTOR3( x, y, z );
}

//-----------------------------------------------------------------------------
// Name : SetLookPos()
// Desc : _̐ݒ
// Argu : x = wW
//		  y = xW
//		  z = yW
//-----------------------------------------------------------------------------
void CCamera::SetLookPos( float x, float y, float z )
{
	m_LookPos = D3DXVECTOR3( x, y, z );
}

//-----------------------------------------------------------------------------
// Name : SetUpVector()
// Desc : xNg̐ݒ
// Argu : x = wW
//		  y = xW
//		  z = yW
//-----------------------------------------------------------------------------
void CCamera::SetUpVector( float x, float y, float z )
{
	m_UpVector = D3DXVECTOR3( x, y, z );
}

//-----------------------------------------------------------------------------
// Name : SetViewAngle()
// Desc : p̔w@
// Argu : n = p
//-----------------------------------------------------------------------------
void CCamera::SetViewAngle( int n )
{
	m_fViewAngle = n;
}

//-----------------------------------------------------------------------------
// Name : SetAspectRatio()
// Desc : AXyNg̐ݒ
// Argu : n = AXyNg
//-----------------------------------------------------------------------------
void CCamera::SetAspectRatio( float n )
{
	m_fAspectRatio = n;
}

//-----------------------------------------------------------------------------
// Name : SetViewArea()
// Desc : eʂ̐ݒ
// Argu : min = Oe
//		  max = e
//-----------------------------------------------------------------------------
void CCamera::SetViewArea( float min, float max )
{
	m_fViewMin = min;
	m_fViewMax = max;
}

//-----------------------------------------------------------------------------
// Name : SetTransform()
// Desc : ݒXV
//-----------------------------------------------------------------------------
void CCamera::SetTransform()
{
	D3DXMatrixLookAtLH( &m_mView, &m_EyePos, &m_LookPos, &m_UpVector );
	d3d.m_pD3DDev->SetTransform( D3DTS_VIEW, &m_mView );

	D3DXMatrixPerspectiveFovLH( &m_mProjection, m_fViewAngle,
								m_fAspectRatio, m_fViewMin, m_fViewMax );
	d3d.m_pD3DDev->SetTransform( D3DTS_PROJECTION, &m_mProjection );
}

//-----------------------------------------------------------------------------
// Name : GetpViewMatrix()
//-----------------------------------------------------------------------------
const D3DXMATRIX* CCamera::GetpViewMatrix()
{
	return &m_mView;
}

//-----------------------------------------------------------------------------
// Name : GetpProjectionMatrix()
//-----------------------------------------------------------------------------
const D3DXMATRIX* CCamera::GetpProjectionMatrix()
{
	return &m_mProjection;
}