#include "../Include/AppSystem.h"

CD3D d3d;

//-----------------------------------------------------------------------------
// Name : CD3D()
//-----------------------------------------------------------------------------
CD3D::CD3D()
{
//	m_bDeviceLost	= false;
	m_pD3D			= 0;
	m_pD3DDev		= 0;
	m_bVSync		= true;
	m_bChangeWindow = true;
}


//-----------------------------------------------------------------------------
// Name : ~CD3D()
//-----------------------------------------------------------------------------
CD3D::~CD3D()
{
	RELEASE( m_pD3DDev );
	RELEASE( m_pD3D );
}

//-----------------------------------------------------------------------------
// Name : InitD3DObject()
// Desc : D3D IuWFNg̏
//-----------------------------------------------------------------------------
bool CD3D::InitD3DObject()
{	
	d3d.camera.Init();	
	if ( !d3d.dxsprite.Init() ) return false;
	if ( !d3d.font.Init() ) return false;
	Init();

	return true;
}

//-----------------------------------------------------------------------------
// Name : Init()
// Desc : ݒ̏
//-----------------------------------------------------------------------------
bool CD3D::Init()
{
	m_pD3DDev->SetSamplerState( 0, D3DSAMP_ADDRESSV, D3DTADDRESS_BORDER );
	m_pD3DDev->SetSamplerState( 0, D3DSAMP_ADDRESSU, D3DTADDRESS_BORDER );

	return true;
}

//-----------------------------------------------------------------------------
// Name : Create()
// Desc : D3D̍쐬
//-----------------------------------------------------------------------------
bool CD3D::Create( HWND hWnd, int x, int y, D3DFORMAT *ZBufferFormat,
				bool bWindowMode )
{
	m_hWnd = hWnd;

	// Direct3D C^[tFCX̍쐬
	m_pD3D = Direct3DCreate9( 0x09b0/*D3D_SDK_VERSION*/);
	if ( m_pD3D == 0 ) {		
		ErrLog( "CD3D::Create() : Direct3DCreate9()" );
		MesBox( "G[", "Direct3D ̍쐬Ɏs܂" );
		return false;
	}

    // ʃ[h̎擾
    D3DDISPLAYMODE d3ddm;
	m_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm );

	// Zobt@tH[}bg
	D3DFORMAT D3DFormat;
	if ( ZBufferFormat ) D3DFormat = *ZBufferFormat;
	else D3DFormat = D3DFMT_D24S8;

	// Direct3D p[^̐ݒ
	// EBhE
	ZeroMemory( &m_d3dppWindow, sizeof( m_d3dppWindow ) );
	m_d3dppWindow.BackBufferWidth				= x;		// obNobt@̕
	m_d3dppWindow.BackBufferHeight				= y;		// obNobt@̍
	m_d3dppWindow.BackBufferCount				= 1;						// obNobt@̐
	m_d3dppWindow.BackBufferFormat				= d3ddm.Format;				// obNobt@̃tH[}bg
	m_d3dppWindow.MultiSampleType				= D3DMULTISAMPLE_NONE;		// }`TvO̎
	m_d3dppWindow.MultiSampleQuality			= 0;						// }`TvO̕i
	m_d3dppWindow.SwapEffect					= D3DSWAPEFFECT_DISCARD;	// XbvGtFNg
	m_d3dppWindow.hDeviceWindow					= hWnd;					// foCXEChEnh
	m_d3dppWindow.Windowed						= TRUE;						// EBhEE[h
	m_d3dppWindow.EnableAutoDepthStencil		= TRUE;						// yobt@̗L
	m_d3dppWindow.AutoDepthStencilFormat		= D3DFormat;				// yobt@̃tH[}bg
    m_d3dppWindow.Flags							= D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;						// ݒ
	m_d3dppWindow.FullScreen_RefreshRateInHz	= 0;						// tbV[g
	m_d3dppWindow.PresentationInterval			= 
		m_bVSync ? D3DPRESENT_INTERVAL_ONE : D3DPRESENT_INTERVAL_IMMEDIATE;	// ʂ̍XVԊu

	// tXN[
	m_d3dppFull							= m_d3dppWindow;
	m_d3dppFull.Windowed				= FALSE;
	m_d3dppFull.BackBufferFormat		= D3DFMT_X8R8G8B8;

	// p[^ݒ
	SetWindowParam( bWindowMode );

	// Direct3D foCX̍쐬
	if ( !CreateDevice() ) {
		ErrLog( "CD3D::Create() : CreateDevice()" );
		return false;
	}

	// r[|[g̐ݒ
	if ( !SetViewport() ) {		
		ErrLog( "CD3D::Create() : SetViewport()" );
		MesBox( "G[", "r[|[g̐ݒɎs܂" );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetBackBufferSize()
// Desc : obNobt@ETCY̐ݒ
// Argu : x = X TCY
//		  y = Y TCY
//-----------------------------------------------------------------------------
void CD3D::SetBackBufferSize( int x, int y )
{
	m_d3dppWindow.BackBufferWidth	= x;
	m_d3dppWindow.BackBufferHeight	= y;
	m_d3dppFull.BackBufferWidth		= x;
	m_d3dppFull.BackBufferHeight	= y;
}

//-----------------------------------------------------------------------------
// Name : SetViewport()
// Desc : r[|[g̐ݒ
//-----------------------------------------------------------------------------
bool CD3D::SetViewport()
{
	// r[|[g̐ݒ
	D3DVIEWPORT9 vp;
	vp.X		= 0;
	vp.Y		= 0;
	vp.Width	= m_d3dpp.BackBufferWidth;
	vp.Height	= m_d3dpp.BackBufferHeight;
	vp.MinZ		= 0.0f;
	vp.MaxZ		= 1.0f;
	if ( FAILED( m_pD3DDev->SetViewport( &vp ) ) ) {
		return false;
	}
	return true;
}

//-----------------------------------------------------------------------------
// Name : CreateDevice()
// Desc : Direct3D foCX̍쐬
// Rtn  : true  : 
//		  false : s
//-----------------------------------------------------------------------------
bool CD3D::CreateDevice()
{
	static HRESULT hr;
    // T&L HAL foCX̐
	hr = m_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, m_hWnd, 
							   D3DCREATE_HARDWARE_VERTEXPROCESSING, 
							   &m_d3dpp, &m_pD3DDev );
	if ( FAILED( hr ) ) {
		ErrLog( "CD3D::CreateDevice() : CreateDevice() T&L HAL\n"
				"		%s", DXGetErrorString9( hr ) );
        // s HAL foCX̐
		hr = m_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, m_hWnd,
								   D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								   &m_d3dpp, &m_pD3DDev );
		if ( FAILED( hr ) ) {
			ErrLog( "CD3D::CreateDevice() : CreateDevice() HAL\n"
					"		%s", DXGetErrorString9( hr ) );
			MesBox( "G[", "Direct3D foCX̍쐬Ɏs܂" );
			return false;
			/*
            // s REF foCX̐
            if ( FAILED( m_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, m_hWnd,
											      D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
												  &m_d3dpp, &m_pD3DDev ) ) ) {
                return false;
            }
			*/
		}
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : ResetDevice()
// Desc : Direct3D foCX̕
//-----------------------------------------------------------------------------
bool CD3D::RestoreDevice()
{
	HRESULT hr;

	OnLostDevice();

	// foCX̕
	hr = m_pD3DDev->Reset( &m_d3dpp );
	if ( FAILED( hr ) ) {
		if ( hr == D3DERR_DEVICELOST ) {
			return false;
		}
	}

	if( !SetViewport() ) return false;

	OnResetDevice();
	m_bDeviceLost = 0;
	m_bChangeWindow = true;

	Init();	// ݒ̏

	return true;
}

//-----------------------------------------------------------------------------
// Name : CheckDevice()
// Desc : Direct3D foCX̃`FbN
//		  foCXĂƂɁAs
// Rtn  : true  : foCX̉񕜂\
//		: false : foCX͌ݕłȂ
//-----------------------------------------------------------------------------
bool CD3D::CheckDevice()
{
	if ( m_bDeviceLost ) {
		HRESULT hr;
		Sleep( 100 );
		// foCXԂ̃`FbN
		hr = m_pD3DDev->TestCooperativeLevel();
		// A\
		if ( hr == D3DERR_DEVICENOTRESET ) {
			// foCX̕
			if ( !RestoreDevice() ) {
				return false;
			}
		}
		// ݃foCX̕łȂ
		else if ( hr == D3DERR_DEVICELOST ) {
			return false;
		}
		m_bDeviceLost = 0;
	}

	return true;
}


//-----------------------------------------------------------------------------
// Name : SetWindowParam
// Desc : foCXp[^ݒ肷
// Argu : true : EBhEEp[^ݒ
//		  false : tXN[Ep[^ݒ
//-----------------------------------------------------------------------------
void CD3D::SetWindowParam( bool bl )
{
	if ( bl ) m_d3dpp = m_d3dppWindow;
	else m_d3dpp = m_d3dppFull;
}

//-----------------------------------------------------------------------------
// Name : GetpD3D()
// Desc : Direct3D C^[tFCX̎擾
// Rtn  : Direct3D C^[tFCX
//-----------------------------------------------------------------------------
LPDIRECT3D9 CD3D::GetpD3D()
{
	return m_pD3D;
}

//-----------------------------------------------------------------------------
// Name : GetpD3DDevice()
// Desc : Direct3D foCX̎擾
// Rtn  : Direct3D foCXEC^[tFCX
//-----------------------------------------------------------------------------
LPDIRECT3DDEVICE9 CD3D::GetpD3DDev()
{
	return m_pD3DDev;
}

//-----------------------------------------------------------------------------
// Name : GetD3DParam()
// Desc : Direct3D p[^̎擾
//-----------------------------------------------------------------------------
void CD3D::GetD3DParam( D3DPRESENT_PARAMETERS &rD3DParam )
{
	rD3DParam = m_d3dpp;
}

//-----------------------------------------------------------------------------
// Name : Begin()
// Desc : Direct3D V[̊Jn
// Rtn  : true  : 
//		  false : s
//-----------------------------------------------------------------------------
bool CD3D::Begin()
{
	// V[̊Jn
	if ( FAILED( m_pD3DDev->BeginScene() ) ) {
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : Render()
// Desc : V[`
// Rtn  : true  : 
//		  false : s
//-----------------------------------------------------------------------------
void CD3D::Render()
{
	// V[̏I
	m_pD3DDev->EndScene();

	// ʂ̏
	if ( FAILED( m_pD3DDev->Present( 0, 0, 0, 0 ) ) )
		m_bDeviceLost = 1;
}

//-----------------------------------------------------------------------------
// Name : ClearScene()
// Desc : V[̃NA
// Argu : color = NAF
//-----------------------------------------------------------------------------
void CD3D::ClearScene( D3DCOLOR color )
{
	m_pD3DDev->Clear( 0, 0, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, 
					 color, 1.0f, 0 );
}

//-----------------------------------------------------------------------------
// Name : SetRenderState()
// Desc : _OEXe[g̐ݒ
// Argu : state = foCXEXe[g
//		  value = Xe[gl
//-----------------------------------------------------------------------------
bool CD3D::SetRenderState( D3DRENDERSTATETYPE state, DWORD value )
{
	if ( FAILED( m_pD3DDev->SetRenderState( state, value ) ) )
		return false;
	
	return true;
}

//-----------------------------------------------------------------------------
// Name : SetRenderState()
// Desc : _OEXe[g̐ݒ
//-----------------------------------------------------------------------------
bool CD3D::SetTexture( int n, LPDIRECT3DTEXTURE9 pTexture )
{
	if ( FAILED( m_pD3DDev->SetTexture( 0, pTexture ) ) )
		return false;

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetMaterial()
// Desc : }eA̐ݒ
//-----------------------------------------------------------------------------
bool CD3D::SetMaterial( D3DMATERIAL9 *pMaterial )
{
	if ( FAILED( m_pD3DDev->SetMaterial( pMaterial ) ) )
		return false;

	return true;
}

//-----------------------------------------------------------------------------
// Name : OnLostDevice()
// Desc : foCXȌ
//-----------------------------------------------------------------------------
void CD3D::OnLostDevice()
{
	font.OnLostDevice();
	dxsprite.OnLostDevice();
}

//-----------------------------------------------------------------------------
// Name : OnResetDevice()
// Desc : foCXꂽ̏
//-----------------------------------------------------------------------------
void CD3D::OnResetDevice()
{
	light.Restore();

	font.OnResetDevice();
	dxsprite.OnResetDevice();
}