#include "../Include/AppSystem.h"

static const int g_DrawBufSize = 512;

//-----------------------------------------------------------------------------
// Name : FONT_INFO()
//-----------------------------------------------------------------------------
FONT_INFO::FONT_INFO()
{
	pFont = 0;
}

//-----------------------------------------------------------------------------
// Name : ~FONT_INFO()
//-----------------------------------------------------------------------------
FONT_INFO::~FONT_INFO()
{
	RELEASE( pFont );
}

//-----------------------------------------------------------------------------
// Name : CFont()
//-----------------------------------------------------------------------------
CFont::CFont()
{
	m_pSprite = 0;
}

//-----------------------------------------------------------------------------
// Name : ~CFont()
//-----------------------------------------------------------------------------
CFont::~CFont()
{	
	RELEASE( m_pSprite );
}

//-----------------------------------------------------------------------------
// Name : Init()
// Desc : 
//		  CSprite NXInit()̌ɎsȂ΂Ȃ炢
//-----------------------------------------------------------------------------
bool CFont::Init()
{
	// ftHgtHg̍쐬
	if ( !Create( m_DefaultFont, 16, 0, false, false, SHIFTJIS_CHARSET ) ) {
		ErrLog( "CFont::Init() : Create()" );
		return false;
	}

	// XvCg̍쐬
	static HRESULT hr;
	hr = D3DXCreateSprite( d3d.m_pD3DDev, &m_pSprite );
	if ( FAILED( hr ) ) {
		ErrLog( "CFont::Init() : D3DXCreateSprite()\n"
				"		%s", DXGetErrorString9( hr ) );
		MesBox( "G[", "XvCg̏Ɏs܂" );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : CreateFont()
// Desc : tHg̍쐬
//-----------------------------------------------------------------------------
bool CFont::Create( FONTOBJ &obj, int height, int width, bool bold, bool italic, 
				    BYTE CharSet )
{
	m_vInfo.Create( obj );
	FONT_INFO *pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	pInfo->color = COLOR_XRGB( 0,0,0 );

	// tHg̐ݒ
	D3DXFONT_DESC FontDesc = { 
		height, width, bold ? 700 : 400, 0, italic, CharSet, OUT_DEFAULT_PRECIS, 
		ANTIALIASED_QUALITY, DEFAULT_PITCH | FF_DONTCARE, 0, 0 
	};

	static const int NameSize = 32;
	static char FontName[NameSize];
	static int n;
	n = _snprintf( FontName, NameSize-1, "FontNumber%d", obj.n );
	if ( n < 0 ) FontName[NameSize-1] = 0;

	lstrcpy( FontDesc.FaceName, FontName );

	// tHg̍쐬
	static HRESULT hr;
	hr = D3DXCreateFontIndirect( d3d.m_pD3DDev, &FontDesc, &( pInfo->pFont ) );
	if ( FAILED( hr ) ) {
		m_vInfo.Delete( obj );	// J
		ErrLog( "CFont::Create() : D3DXCreateFontIndirect()\n"
				"		%s", DXGetErrorString9( hr ) );
		MesBox( "G[", "tHg̍쐬Ɏs܂" );
		return false;
	}

	return true;
}


//-----------------------------------------------------------------------------
// Name : DeleteFont()
// Desc : tHg̍폜
//-----------------------------------------------------------------------------
bool CFont::Delete( FONTOBJ &obj )
{
	if ( m_vInfo.Delete( obj ) ) return true;
	return false;
}

//-----------------------------------------------------------------------------
// Name : Begin()
// Desc : tHg`̊Jn
//-----------------------------------------------------------------------------
bool CFont::Begin()
{
	if ( FAILED( m_pSprite->Begin( 
		D3DXSPRITE_ALPHABLEND | D3DXSPRITE_SORT_TEXTURE ) ) )
		return false;

	return true;
}

//-----------------------------------------------------------------------------
// Name : End()
// Desc : tHg`̏I
//-----------------------------------------------------------------------------
void CFont::End()
{
	m_pSprite->End();
}

//-----------------------------------------------------------------------------
// Name : SetColor()
// Argu : color = F
//-----------------------------------------------------------------------------
bool CFont::SetColor( FONTOBJ obj, D3DCOLOR color )
{
	FONT_INFO *pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	pInfo->color = color;

	return true;
}

//-----------------------------------------------------------------------------
// Name : DrawText()
// Desc : `
// Argu : x = `JnwW
//		  y = `JnxW
//		  obj = tHgEIuWFNg( 0 = ftHgtHg )
//		  *str, ... = `悷镶( printfƓl̋Lq@ )
//-----------------------------------------------------------------------------
bool CFont::DrawText( FONTOBJ obj, int x, int y, char *str, ... )
{
	FONT_INFO *pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	static HRESULT hr;
	static char buf[g_DrawBufSize];
	static int n;
	va_list ap;
	va_start( ap, str );
	n = _vsnprintf( buf, g_DrawBufSize-1, str, ap );
	va_end( ap );

	// I[o[
	if ( n == -1 ) buf[g_DrawBufSize-1] = 0;
	// \Ȃ
	else if ( n == 0 ) return true;
	// s̃G[
	else if ( n < 0 ) {
		ErrLog( "CFont::DrawText() : _vsnprintf()" );
		return false;
	}

	static RECT rc;
	SetRect( &rc, x, y, 0, 0 );

	hr = pInfo->pFont->DrawText( 0, buf, -1, &rc, DT_NOCLIP, pInfo->color );
	if ( FAILED( hr ) ) {
		ErrLog( "CFont::DrawText() : DrawText()\n"
				"		%s", DXGetErrorString9( hr ) );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : OnLostDevice()
//-----------------------------------------------------------------------------
bool CFont::OnLostDevice()
{
	static HRESULT hr;
	static int size;
	m_vInfo.GetSize( size );

	for ( int i = 0; i < size; i++ ) {
		if ( m_vInfo.GetpObject( i ) ) {
			hr = m_vInfo.GetpObject( i )->pFont->OnLostDevice();
			if ( FAILED( hr ) ) break;
		}
	}

	if ( FAILED( hr ) ) {
		ErrLog( "CFont::OnLostDevice() : OnLostDevice()\n"
				"		%s", DXGetErrorString9( hr ) );
		MesBox( "G[", "tHgEfoCX̏Ɏs܂" );
		return false;
	}

	if ( m_pSprite ) {
		hr = m_pSprite->OnLostDevice();
		if ( FAILED( hr ) ) {
			ErrLog( "CFont::OnLostDevice() : OnLostDevice()\n"
					"		%s", DXGetErrorString9( hr ) );
			MesBox( "G[", "XvCgEfoCX̏Ɏs܂" );
			return false;
		}
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : OnResetDevice()
//-----------------------------------------------------------------------------
bool CFont::OnResetDevice()
{
	static HRESULT hr;
	static int size;
	m_vInfo.GetSize( size );
	
	for ( int i = 0; i < size; i++ ) {
		if ( m_vInfo.GetpObject( i ) ) {
			hr = m_vInfo.GetpObject( i )->pFont->OnResetDevice();
			if ( FAILED( hr ) ) break;
		}
	}

	if ( FAILED( hr ) ) {
		ErrLog( "CFont::OnResetDevice() : pFont->OnResetDevice()\n"
				"		%s", DXGetErrorString9( hr ) );
		MesBox( "G[", "tHgEfoCX̕Ɏs܂" );
		return false;
	}

	if ( m_pSprite ) {
		hr = m_pSprite->OnResetDevice();
		if ( FAILED( hr ) ) {
			ErrLog( "CFont::OnResetDevice() : m_pSprite->OnResetDevice()\n"
					"		%s", DXGetErrorString9( hr ) );
			MesBox( "G[", "XvCgEfoCX̕Ɏs܂" );
			return false;
		}
	}

	return true;
}