#include "../Include/AppSystem.h"

//-----------------------------------------------------------------------------
// Name : CKey()
//-----------------------------------------------------------------------------
CKey::CKey()
{
	m_pKeyDev = 0;
}

//-----------------------------------------------------------------------------
// Name : ~CKey()
//-----------------------------------------------------------------------------
CKey::~CKey()
{
	// ͐̒~
	if ( m_pKeyDev ) {
		m_pKeyDev->Unacquire();
		RELEASE( m_pKeyDev );	// DirectInput L[EfoCX
	}
}

//-----------------------------------------------------------------------------
// Name : Create()
// Desc : 쐬
//-----------------------------------------------------------------------------
bool CKey::Create( HWND hWnd, LPDIRECTINPUT8 pDInput )
{
	HRESULT hr;
	// L[EfoCX̏
	hr = pDInput->CreateDevice( GUID_SysKeyboard, &m_pKeyDev, 0 );
	if ( FAILED( hr ) ) {
		return false;
	}

	// f[^tH[}bg̐ݒ
    hr = m_pKeyDev->SetDataFormat( &c_dfDIKeyboard );
    if ( FAILED( hr ) ) {
		return false;
	}

	// [h̐ݒ( tHAOEhr[h )
	hr = m_pKeyDev->SetCooperativeLevel( hWnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND );
	if ( FAILED( hr ) ) {
		return false;
	}

	// obt@OEf[^̎擾邽߁Aobt@ETCY̐ݒ
	DIPROPDWORD diprop;
	diprop.diph.dwSize			= sizeof( diprop ); 
	diprop.diph.dwHeaderSize	= sizeof( diprop.diph ); 
	diprop.diph.dwObj			= 0;
	diprop.diph.dwHow			= DIPH_DEVICE;
	diprop.dwData				= 100;//DIDEVICE_BUFFERSIZE;
	hr = m_pKeyDev->SetProperty( DIPROP_BUFFERSIZE, &diprop.diph );
	if ( FAILED( hr ) ) {
		return false;
	}

	// foCX̊Jn
	m_pKeyDev->Acquire();

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetState()
// Desc : L[̏Ԃݒ
//-----------------------------------------------------------------------------
bool CKey::SetState()
{
	HRESULT hr;

	ZeroMemory( &m_KeyState, sizeof( m_KeyState ) );
	// L[̓͏̎擾
	hr = m_pKeyDev->GetDeviceState( KEY_MAX, m_KeyState );
	if ( FAILED( hr ) ) {
		if ( hr == DIERR_INPUTLOST ) m_pKeyDev->Acquire();
		return false;
	}

	m_dwItems = 1;

	// L[̉A̎擾
	hr = m_pKeyDev->GetDeviceData( sizeof( DIDEVICEOBJECTDATA ), 
											&m_Keyod, &m_dwItems, 0 );
	if ( FAILED( hr ) ) {
		if ( hr == DIERR_INPUTLOST ) m_pKeyDev->Acquire();
		return false;
	}

	// L[n
	for ( int i = 0; i < KEY_MAX; i++ ) {
		if ( m_KeyState[i] )
			m_KeyState[i] = STATE_HOLD;
		else
			m_KeyState[i] = STATE_FREE;
	}

	if ( m_dwItems != 0 ) {
		if ( m_Keyod.dwData & 0x80 )
			m_KeyState[ m_Keyod.dwOfs ] = STATE_PUSH;
		else
			m_KeyState[ m_Keyod.dwOfs ] = STATE_PULL;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : GetState()
// Desc : L[̏Ԃ擾
//-----------------------------------------------------------------------------
void CKey::GetState( KEYOBJ &buf )
{
	buf = m_KeyState;
}

//-----------------------------------------------------------------------------
// Name : Restore()
// Desc : foCX̍Ď擾
//-----------------------------------------------------------------------------
void CKey::Restore()
{
	if ( m_pKeyDev ) m_pKeyDev->Acquire();	
}
