#include "../Include/AppSystem.h"

//-----------------------------------------------------------------------------
// Name : Create()
// Desc : Cg̍쐬
// Argu : obj = LIGOBJ IuWFNg
//-----------------------------------------------------------------------------
bool CLightManager::Create( LIGOBJ &obj,  D3DLIGHTTYPE type )
{
	m_vInfo.Create( obj );
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj.n );

	ZeroMemory( &( pInfo->D3DLight ), sizeof( D3DLIGHT9 ) );
	pInfo->D3DLight.Type		= type;		// ̎
    pInfo->D3DLight.Diffuse.r	= 1.0f;		// fBt[Y q
    pInfo->D3DLight.Diffuse.g	= 1.0f;		// fBt[Y f
    pInfo->D3DLight.Diffuse.b	= 1.0f;		// fBt[Y a
    pInfo->D3DLight.Diffuse.a	= 1.0f;		// fBt[Y `
    pInfo->D3DLight.Specular.r	= 0.0f;		// XyL[ q
    pInfo->D3DLight.Specular.g	= 0.0f;		// XyL[ f
    pInfo->D3DLight.Specular.b	= 0.0f;		// XyL[ a
    pInfo->D3DLight.Specular.a	= 0.0f;		// XyL[ `
    pInfo->D3DLight.Ambient.r	= 0.7f;		// ArGg q
    pInfo->D3DLight.Ambient.g	= 0.7f;		// ArGg f
    pInfo->D3DLight.Ambient.b	= 0.7f;		// ArGg a
    pInfo->D3DLight.Ambient.a	= 1.0f;		// ArGg `

	pInfo->D3DLight.Direction	= D3DXVECTOR3( -1, -2, 1 );
	pInfo->D3DLight.Position	= D3DXVECTOR3( 0, 0, 0 );
	pInfo->D3DLight.Theta		= D3DXToRadian( 45 );
	pInfo->D3DLight.Phi			= D3DXToRadian( 45 );
	pInfo->D3DLight.Range		= sqrt( FLT_MAX );

	pInfo->bEnable = true;

	return true;
}

//-----------------------------------------------------------------------------
// Name : Delete()
// Desc : Cg̍폜
// Argu : obj = LIGOBJ IuWFNg
//-----------------------------------------------------------------------------
bool CLightManager::Delete( LIGOBJ &obj )
{
	// LIGOBJ ̃`FbN
	if ( m_vInfo.Delete( obj ) ) return true;
	return false;
}

//-----------------------------------------------------------------------------
// Name : SetEnable()
// Desc : Cg̗L
// Argu : obj	= LIGOBJ IuWFNg
//		  bool	= CgON, OFF
//-----------------------------------------------------------------------------
bool CLightManager::SetEnable( LIGOBJ obj, bool bl )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	pInfo->bEnable = bl;

	d3d.m_pD3DDev->SetLight( obj.n, &( pInfo->D3DLight ) );
	d3d.m_pD3DDev->LightEnable( obj.n, pInfo->bEnable );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetLight()
// Desc : Cg̐ݒ̍XV
// Argu : obj	= LIGOBJ IuWFNg
//-----------------------------------------------------------------------------
bool CLightManager::SetLight( LIGOBJ obj )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	d3d.m_pD3DDev->SetLight( obj.n, &( pInfo->D3DLight ) );
	d3d.m_pD3DDev->LightEnable( obj.n, pInfo->bEnable );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetType()
// Desc : Cg̎ނ̐ݒ
// Argu : obj	= LIGOBJ IuWFNg
//		  type  = Cg̎
//-----------------------------------------------------------------------------
bool CLightManager::SetType( LIGOBJ obj, D3DLIGHTTYPE type )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	pInfo->D3DLight.Type = type;

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetDeffuse()
// Desc : ft[YF̐ݒ
// Argu : obj		 = LIGOBJ IuWFNg
//		  r, g, b, a = ft[YF
//-----------------------------------------------------------------------------
bool CLightManager::SetDeffuse( LIGOBJ obj, float r, float g, float b, float a )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

    pInfo->D3DLight.Diffuse.r	= r;	// fBt[Y q
    pInfo->D3DLight.Diffuse.g	= g;	// fBt[Y f
    pInfo->D3DLight.Diffuse.b	= b;	// fBt[Y a
    pInfo->D3DLight.Diffuse.a	= a;	// fBt[Y `

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetSpecular()
// Desc : XyLF̐ݒ
// Argu : obj		 = LIGOBJ IuWFNg
//		  r, g, b, a = XyLF
//-----------------------------------------------------------------------------
bool CLightManager::SetSpecular( LIGOBJ obj, float r, float g, float b, float a )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

    pInfo->D3DLight.Specular.r	= r;
    pInfo->D3DLight.Specular.g	= g;
    pInfo->D3DLight.Specular.b	= b;
    pInfo->D3DLight.Specular.a	= a;

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetAmbient()
// Desc : ArGgF̐ݒ
// Argu : obj		 = LIGOBJ IuWFNg
//		  r, g, b, a = ArGgF
//-----------------------------------------------------------------------------
bool CLightManager::SetAmbient( LIGOBJ obj, float r, float g, float b, float a )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

    pInfo->D3DLight.Ambient.r	= r;
    pInfo->D3DLight.Ambient.g	= g;
    pInfo->D3DLight.Ambient.b	= b;
    pInfo->D3DLight.Ambient.a	= a;

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetPos()
// Desc : Cg̐ݒ̍XV
// Argu : obj	  = LIGOBJ IuWFNg
//		  x, y, z = ʒu
//-----------------------------------------------------------------------------
bool CLightManager::SetPos( LIGOBJ obj, float x, float y, float z )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	pInfo->D3DLight.Position = D3DXVECTOR3( x, y, z );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetDirection()
// Desc : Cg̐̕ݒ
// Argu : obj	  = LIGOBJ IuWFNg
//		  x, y, z = 
//-----------------------------------------------------------------------------
bool CLightManager::SetDirection( LIGOBJ obj, float x, float y, float z )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	D3DXVECTOR3 VecDir = D3DXVECTOR3( x, y, z );
	D3DXVec3Normalize( (D3DXVECTOR3*) &pInfo->D3DLight.Direction, &VecDir );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetRange()
// Desc : Cg̗L̐ݒ
// Argu : obj	= LIGOBJ IuWFNg
//		  n		= L
//-----------------------------------------------------------------------------
bool CLightManager::SetRange( LIGOBJ obj, float n )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	static float FlTMAXSqrt = sqrt( FLT_MAX ); 
	if ( n > FlTMAXSqrt ) n = FlTMAXSqrt;

	pInfo->D3DLight.Range  = n;

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetConeAngle()
// Desc : Cg̃R[px̐ݒ
// Argu : obj	= LIGOBJ IuWFNg
//		  in	= R[̓̊px
//		  out	= R[̊O̊px
//-----------------------------------------------------------------------------
bool CLightManager::SetConeAngle( LIGOBJ obj, float in, float out )
{
	static LIGHT_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	if ( in > out ) in = out;

	pInfo->D3DLight.Theta	= D3DXToRadian( in );
	pInfo->D3DLight.Phi		= D3DXToRadian( out );

	return true;
}

//-----------------------------------------------------------------------------
// Name : Restore()
// Desc : Cg̐ݒ̍Ď擾
//-----------------------------------------------------------------------------
void CLightManager::Restore()
{
	static LIGOBJ obj;
	static int size;
	m_vInfo.GetSize( size );

	for ( int i = 0; i < size; i++ ) {
		if ( m_vInfo.GetpObject( i ) ) {
			obj.n = i;
			SetLight( obj );
		}
	}
}