#include "../Include/AppSystem.h"

//-----------------------------------------------------------------------------
// Draw()
//-----------------------------------------------------------------------------
bool CLine2D::Draw( float x1, float y1, float x2, float y2, D3DXCOLOR Color )
{
	D3DTLVERTEX Vertex[] = {
		{ x1, y1, 0, 0, Color, 0, 0, 0 },
		{ x2, y2, 0, 0, Color, 0, 0, 0 }
	};

	d3d.GetpD3DDev()->SetFVF( D3DFVF_2DVERTEX );
	HRESULT hr = d3d.GetpD3DDev()->DrawPrimitiveUP( D3DPT_LINELIST, 1, 
		Vertex, sizeof( D3DTLVERTEX ) );
	if ( FAILED( hr ) ) {
		return false;
	}
	return true;
}

//-----------------------------------------------------------------------------
// DrawList()
//-----------------------------------------------------------------------------
bool CLine2D::DrawList( D3DXVECTOR2 *pArray, int size, D3DXCOLOR Color )
{
	D3DTLVERTEX *pVertex = new D3DTLVERTEX[size];

	for ( int i = 0; i < size; i++ ) {
		SetD3DTLVERTEX( pVertex[i], 
			pArray[i].x, pArray[i].y, 0, 0, Color, 0, 0, 0 );
	}

	d3d.GetpD3DDev()->SetFVF( D3DFVF_2DVERTEX );
	HRESULT hr = d3d.GetpD3DDev()->DrawPrimitiveUP( D3DPT_LINESTRIP, size-1, pVertex, sizeof( D3DTLVERTEX ) );
	if ( FAILED( hr ) ) {
		return false;
	}

	delete [] pVertex;

	return true;
}