#include "../Include/AppSystem.h"

//-----------------------------------------------------------------------------
// Name : CMouse()
//-----------------------------------------------------------------------------
CMouse::CMouse()
{
	m_pMouseDev = 0;
	m_MousePos.cx = 0;
	m_MousePos.cy = 0;
}

//-----------------------------------------------------------------------------
// Name : ~CMouse()
//-----------------------------------------------------------------------------
CMouse::~CMouse()
{
	if ( m_pMouseDev ) {
		m_pMouseDev->Unacquire();
		RELEASE( m_pMouseDev );	// DirectInput }EXEfoCX
	}
}

//-----------------------------------------------------------------------------
// Name : Create()
// Desc : 쐬
// Argu : hWnd = EBhEEnh
//		  pDInput = DirectInput foCX
//-----------------------------------------------------------------------------
bool CMouse::Create( HWND hWnd, LPDIRECTINPUT8 pDInput )
{
	HRESULT hr;

	// }EXEfoCX̐
	hr = pDInput->CreateDevice( GUID_SysMouse, &m_pMouseDev, 0 );
	if ( FAILED( hr ) ) {
		return false;
	}

	// f[^tH[}bg̐ݒ
    hr = m_pMouseDev->SetDataFormat( &c_dfDIMouse2 );
    if( FAILED( hr ) ) {
		return false;
	}

	// [h̐ݒ( tHAOEhr[h )
	hr = m_pMouseDev->SetCooperativeLevel( hWnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND );
	if ( FAILED( hr ) ) {
		return false;
	}

	// [hݒiΒl[hɐݒj
	DIPROPDWORD diprop;
	diprop.diph.dwSize			= sizeof( DIPROPDWORD ); 
	diprop.diph.dwHeaderSize	= sizeof( DIPROPHEADER ); 
	diprop.diph.dwObj			= 0;
	diprop.diph.dwHow			= DIPH_DEVICE;
	diprop.dwData				= MOUSE_BUFFER_SIZE;

	// obt@OEf[^擾邽߁Aobt@ETCYݒ
	hr = m_pMouseDev->SetProperty( DIPROP_BUFFERSIZE, &diprop.diph );
	if ( FAILED( hr ) ) {
		return false;
	}

	// foCX̊Jn
	m_pMouseDev->Acquire();

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetState()
// Desc : }EX̏Ԃ̎擾
//-----------------------------------------------------------------------------
bool CMouse::SetState()
{
	HRESULT hr;
	ZeroMemory( &m_dims, sizeof( m_dims ) );
	// }EX̓͏̎擾
	hr = m_pMouseDev->GetDeviceState( sizeof( DIMOUSESTATE2 ), &m_dims );
	if ( FAILED( hr ) ) {
		if ( hr == DIERR_INPUTLOST ) 
			m_pMouseDev->Acquire();
		return false;
	}

	m_dwItems = MOUSE_BUFFER_SIZE;

	// }EX̉A̎擾
	hr = m_pMouseDev->GetDeviceData( sizeof( DIDEVICEOBJECTDATA ), 
									m_Mouseod, &m_dwItems, 0 );
	if ( FAILED( hr ) ) {
		if ( hr == DIERR_INPUTLOST ) 
			m_pMouseDev->Acquire();		
		return false;
	}

	// }EXn
	for ( int i = 0; i < MOUSE_MAX; i++ ) {
		if ( m_dims.rgbButtons[i] )
			m_dims.rgbButtons[i] = STATE_HOLD;
		else
			m_dims.rgbButtons[i] = STATE_FREE;
	}

	// 擾ׂ̐
	for ( i = 0; i < m_dwItems; i++ ) {
			switch ( m_Mouseod[i].dwOfs ) {
				case DIMOFS_BUTTON0: case DIMOFS_BUTTON1: case DIMOFS_BUTTON2:
				case DIMOFS_BUTTON3: case DIMOFS_BUTTON4: case DIMOFS_BUTTON5: 
				case DIMOFS_BUTTON6: case DIMOFS_BUTTON7:
					m_dims.rgbButtons[m_Mouseod[i].dwOfs - DIMOFS_BUTTON0]
						= ( m_Mouseod[i].dwData & 0x80 ) ? STATE_PUSH : STATE_PULL;

					break;
			}
	}

	m_MoveBuf[0] = m_dims.lX;
	m_MoveBuf[1] = m_dims.lY;
	m_MoveBuf[2] = m_dims.lZ;

	return true;
}

//-----------------------------------------------------------------------------
// Name : GetState()
// Desc : }EX̏Ԃ̎擾
//-----------------------------------------------------------------------------
void CMouse::GetState( MOUSEOBJ &buf )
{ 
	buf = m_dims.rgbButtons; 
}

//-----------------------------------------------------------------------------
// Name : SetPos()
// Desc : }EẌʒu̐ݒ
// Argu : x = XW
//		  y = YW
//-----------------------------------------------------------------------------
void CMouse::SetPos( int x, int y )
{
	m_MousePos.cx = x;
	m_MousePos.cy = y;
}

//-----------------------------------------------------------------------------
// Name : GetPos()
// Desc : }EẌʒu̎擾
// Argu : *px = XWi[
//		  *py = YWi[
//-----------------------------------------------------------------------------
void CMouse::GetPos( SIZE &pos )
{
	pos = m_MousePos;
}

//-----------------------------------------------------------------------------
// Name : Restore()
// Desc : }EXEfoCX̍Ď擾
//-----------------------------------------------------------------------------
void CMouse::Restore()
{ 
	if ( m_pMouseDev ) m_pMouseDev->Acquire(); 
}

//-----------------------------------------------------------------------------
// Name : GetMove()
// Desc : }EẌړʂ̎擾
//-----------------------------------------------------------------------------
void CMouse::GetMove( long &n, MOUSE_MOVE move )
{ 
	n = m_MoveBuf[move]; 
}
