#include "../Include/AppSystem.h"

CDSoundManager sound;

//-----------------------------------------------------------------------------
// Name : _SOUND_INFO()
//-----------------------------------------------------------------------------
SOUND_INFO::SOUND_INFO()
{
	pDSoundBuffer = 0;
	pDSound3DBuffer = 0;
}

//-----------------------------------------------------------------------------
// Name : ~_SOUND_INFO()
//-----------------------------------------------------------------------------
SOUND_INFO::~SOUND_INFO()
{
	// OɁAĐ~
	if ( pDSoundBuffer ) {
		pDSoundBuffer->Stop();
		RELEASE( pDSoundBuffer );
	}

	RELEASE( pDSound3DBuffer );
}

//-----------------------------------------------------------------------------
// Name : CopyMem()
// Desc : ̃Rs[
//-----------------------------------------------------------------------------
bool CDSoundManager::CopyMem( LPDIRECTSOUNDBUFFER8 pSoundBuffer, DWORD *pWaveData, 
							DWORD WaveSize )
{
	static HRESULT hr;

	static LPVOID pMem1, pMem2;
	static DWORD dwSize1, dwSize2;

	hr = pSoundBuffer->Lock( 0, WaveSize, &pMem1, &dwSize1, &pMem2, &dwSize2, 0 );
	if( FAILED( hr ) ) {
		RELEASE( pSoundBuffer );
		return false;
	}
	CopyMemory( pMem1, pWaveData, dwSize1 );
	if( dwSize2 != 0 )
		CopyMemory( pMem2, ( LPVOID )( ( LPBYTE )pWaveData + dwSize1 ), dwSize2 );
	hr = pSoundBuffer->Unlock( pMem1, dwSize1, pMem2, dwSize2 );
	if( FAILED( hr ) ) {
		ErrLog( "CDSoundManager::CopyMem() : Unlock\n"
				"		%s", DXGetErrorString9( hr ) );
		RELEASE( pSoundBuffer );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : CDSoundManager()
//-----------------------------------------------------------------------------
CDSoundManager::CDSoundManager()
{
	m_pDSound = 0;
	m_pListener = 0;
}

//-----------------------------------------------------------------------------
// Name : ~CDSoundManager()
//-----------------------------------------------------------------------------
CDSoundManager::~CDSoundManager()
{
	// TEh̉
	m_vInfo.AllDelete();
	
	RELEASE( m_pListener );
	RELEASE( m_pDSound );
}

//-----------------------------------------------------------------------------
// Name : GetpSoundInfo()
// Desc : SOUND_INFO |C^̎擾
//-----------------------------------------------------------------------------
SOUND_INFO* CDSoundManager::GetpSoundInfo( SNDOBJ obj )
{
	return m_vInfo.GetpObject( obj );
}

//-----------------------------------------------------------------------------
// Name : Init()
// Desc : 
//-----------------------------------------------------------------------------
bool CDSoundManager::Init( HWND hWnd )
{
	static HRESULT hr;

	// DirectSound IuWFNg̍쐬
	if ( FAILED( DirectSoundCreate8( 0, &m_pDSound, 0 ) ) ) {
		MesBox( "G[", "DirectSound ̍쐬Ɏs܂" );
		return false;
	}

	// x̐ݒ
	if ( FAILED( m_pDSound->SetCooperativeLevel( hWnd, DSSCL_PRIORITY ) ) ) {
		MesBox( "G[", "DirectSound ̋x̐ݒɎs܂" );
		return false;
	}

	// vC}obt@̍쐬
	DSBUFFERDESC dsbd;
	ZeroMemory( &dsbd, sizeof( DSBUFFERDESC ) );
	dsbd.dwSize			= sizeof( DSBUFFERDESC );
	dsbd.dwFlags		= DSBCAPS_CTRL3D | DSBCAPS_PRIMARYBUFFER;

	// DirectSoundBuffer ̍쐬
	LPDIRECTSOUNDBUFFER pDSB;
	if ( FAILED( m_pDSound->CreateSoundBuffer( &dsbd, &pDSB, 0 ) ) ) {
		MesBox( "G[", "DirectSoundBuffer ̍쐬Ɏs܂" );
		return false;
	}

	// Xi[̍쐬
	hr = pDSB->QueryInterface( IID_IDirectSound3DListener8, ( LPVOID* ) &m_pListener );
	RELEASE( pDSB );
	if ( FAILED( hr ) ) {
		ErrLog( "CDSoundManager::Init()\n"
				"	%s", DXGetErrorString9( hr ) );
		MesBox( "G[", "Xi[̍쐬Ɏs܂" );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetDSBufferDesc()
// Desc : TEh̍쐬
// Argu : dsbd = DSBUFFERDESC IuWFNg
//		  dwBufferByte = obt@̃oCg
//		  pdwFormat = LPWAVEFORMATEX tH[}bg
//		  bSound3D : true  = 3DTEh
//				   : false = 2DTEh
//-----------------------------------------------------------------------------
bool CDSoundManager::SetDSBufferDesc( DSBUFFERDESC &dsbd, DWORD dwBufferBytes, 
									  WAVEFORMATEX *pdwFormat, bool bSound3D )
{
	// TEhݒ
	ZeroMemory( &dsbd, sizeof( DSBUFFERDESC ) );
	dsbd.dwSize			= sizeof( DSBUFFERDESC );
	dsbd.dwBufferBytes	= dwBufferBytes;
	dsbd.lpwfxFormat	= pdwFormat;
	// 3DTEh̐ݒ
	if ( bSound3D ) {
		if ( dsbd.lpwfxFormat == 0 ) return false;

		if ( dsbd.lpwfxFormat->nChannels != 1 ) {
			ErrLog( "CDSoundManager::SetDSBufferDesc()\n"
					"		3DTEhɃ}``l͎gpłȂBnChannels = %d",
					dsbd.lpwfxFormat->nChannels ); 
			MesBox( "G[", "3DTEhɂ̓}``l͎gpł܂" );
			return false;
		}

		dsbd.dwFlags = DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_CTRL3D | 
			DSBCAPS_GLOBALFOCUS | DSBCAPS_LOCDEFER | DSBCAPS_CTRLVOLUME | 
			DSBCAPS_CTRLFREQUENCY;
	}
	// 2DTEh̐ݒ
	else {
		dsbd.dwFlags = DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_CTRLPAN | 
			DSBCAPS_GLOBALFOCUS | DSBCAPS_LOCDEFER | DSBCAPS_CTRLVOLUME | 
			DSBCAPS_CTRLFREQUENCY;
	}
	return true;
}

//-----------------------------------------------------------------------------
// Name : CreateSound()
// Desc : TEh̍쐬
// Argu : obj		= SNDOBJ IuWFNg
//		  filename	= t@C
//-----------------------------------------------------------------------------
bool CDSoundManager::CreateSound( SNDOBJ &obj, char *filename, bool b3D )
{
	static HRESULT hr;

	// WAVE t@C̓ǂݍ
	CSoundReader SoundReader;
	if ( PathMatchSpec( filename, "*.wav" ) ) {
		if ( !SoundReader.WaveOpen( filename ) ) {
			ErrLog( "CDSoundManager::CreateSound() : WaveOpen()" );
			return false;
		}
		if ( !SoundReader.WaveRead() ) {
			ErrLog( "CDSoundManager::CreateSound() : WaveRead()" );
			return false;
		}
	}
	// OGG t@Cǂݍ
	else if ( PathMatchSpec( filename, "*.ogg" ) ) {
		if ( !SoundReader.OggOpen( filename ) ) {
			ErrLog( "CDSoundManager::CreateSound() : OggOpen()" );		
			return false;
		}
		if ( !SoundReader.OggRead() ) {
			ErrLog( "CDSoundManager::CreateSound() : OggRead()" );
			return false;
		}
	}
	else {
		// gq.wav, .oggȊOł
		ErrLog( "CDSoundManager::CreateSound()\n"
				"		%s ͑ΉĂȂt@C", filename );
		MesBox( "G[", "%s ͑ΉĂȂt@CłB", filename );
		return false;
	}

	// TEhݒ
	static DSBUFFERDESC dsbd;
	if ( !SetDSBufferDesc( dsbd, SoundReader.GetSize(),
						   &( SoundReader.GetFormat() ), b3D ) ) return false; 
/*
	// TEhݒ
	DSBUFFERDESC dsbd;
	ZeroMemory( &dsbd, sizeof( DSBUFFERDESC ) );
	dsbd.dwSize			= sizeof( DSBUFFERDESC );
	dsbd.dwBufferBytes	= SoundReader.GetSize();
	dsbd.lpwfxFormat	= &( SoundReader.GetFormat() );
	// 3DTEh̐ݒ
	if ( b3D ) {
		if ( dsbd.lpwfxFormat->nChannels != 1 ) {
			MesBox( "G[", "3DTEhɂ̓}``l͎gpł܂\n"
				   "%s", filename );
			return false;
		}

		dsbd.dwFlags = DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_CTRL3D | 
			DSBCAPS_GLOBALFOCUS | DSBCAPS_LOCDEFER | DSBCAPS_CTRLVOLUME | 
			DSBCAPS_CTRLFREQUENCY;
	}
	// 2DTEh̐ݒ
	else {
		dsbd.dwFlags = DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_CTRLPAN | 
			DSBCAPS_GLOBALFOCUS | DSBCAPS_LOCDEFER | DSBCAPS_CTRLVOLUME | 
			DSBCAPS_CTRLFREQUENCY;
	}
	*/

	// DirectSoundBuffer ̍쐬
	LPDIRECTSOUNDBUFFER pDSB;
	hr = m_pDSound->CreateSoundBuffer( &dsbd, &pDSB, 0 );
	if ( FAILED( hr ) ) {
		ErrLog( "CDSoundManager::CreateSound() : CreateSoundBuffer()\n"
				"		%s", DXGetErrorString9( hr ) );
		return false;
	}

	// TEh̍쐬
	m_vInfo.Create( obj );
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// DirectSoundBuffer8 ̍쐬
	hr = pDSB->QueryInterface( IID_IDirectSoundBuffer8,
							   (LPVOID*) &( pInfo->pDSoundBuffer ) );
	if ( FAILED( hr ) ) {
		RELEASE( pDSB );
		Delete( obj );
		ErrLog( "CDSoundManager::CreateSound() : QueryInterface() DirectSoundBuffer8\n"
				"		%s", DXGetErrorString9( hr ) );
		return false;
	}

	if ( b3D ) {
		// DirectSound3DBuffer8 ̍쐬
		hr = pDSB->QueryInterface( IID_IDirectSound3DBuffer8,
				( LPVOID* ) &( pInfo->pDSound3DBuffer ) );
		if ( FAILED( hr ) ) {
			RELEASE( pDSB );
			Delete( obj );
			ErrLog( "CDSoundManager::CreateSound() : QueryInterface() DirectSound3DBuffer8\n"
					"		%s", DXGetErrorString9( hr ) );
			return false;
		}
	}
	RELEASE( pDSB );

	// SoundBuffer Ƀf[^Rs[
	if( !CopyMem( pInfo->pDSoundBuffer, SoundReader.GetpData(),
		SoundReader.GetSize() ) ) {
		RELEASE( pDSB );
		Delete( obj );
		ErrLog( "CDSoundManager::CreateSound() : CopyMem()" );
		return false;
	}
	return true;
}

//-----------------------------------------------------------------------------
// Name : Create()
// Desc : TEh̍쐬
// Argu : obj		= SNDOBJ IuWFNg
//		  filename	= t@C
//-----------------------------------------------------------------------------
bool CDSoundManager::Create( SNDOBJ &obj, char *filename )
{
	if ( !CreateSound( obj, filename, false ) ) {
		ErrLog( "CDSoundManager::Create() : CreateSound()\n"
			    "		%s", filename );
		MesBox( "G[", "%s ̓ǂݍ݂Ɏs܂", filename );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : Create3D()
// Desc : 3D TEh̍쐬
// Argu : obj		= SD3DOBJ IuWFNg
//		  filename	= t@C
//-----------------------------------------------------------------------------
bool CDSoundManager::Create3D( SNDOBJ &obj, char *filename )
{
	if ( !CreateSound( obj, filename, true ) ) {
		ErrLog( "CDSoundManager::Create3D() : CreateSound()\n"
				"		%s", filename );
		MesBox( "G[", "%s ̓ǂݍ݂Ɏs܂", filename );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : Delete()
// Desc : TEh̍폜
// Argu : obj = SNDOBJ IuWFNg
//-----------------------------------------------------------------------------
bool CDSoundManager::Delete( SNDOBJ &obj )
{
	if ( Stop( obj ) ) {
		m_vInfo.Delete( obj );
		return true;
	}
	return false;
}

//-----------------------------------------------------------------------------
// Name : Duplicate()
// Desc : TEh̕
// Argu : obj1 = SNDOBJ IuWFNg
//		  obj2 = SNDOBJ IuWFNg 
//-----------------------------------------------------------------------------
bool CDSoundManager::Duplicate( SNDOBJ &obj1, SNDOBJ obj2, bool bSound3D )
{
	if ( obj2 == obj1 ) return true;

	static SOUND_INFO *pInfo2;
	pInfo2 = m_vInfo.GetpObject( obj2 );
	if ( pInfo2 == 0 ) return false;

	// TEh̍쐬
	m_vInfo.Create( obj1 );
	static SOUND_INFO *pInfo1;
	pInfo1 = m_vInfo.GetpObject( obj1 );
	if ( pInfo1 == 0 ) return false;

	HRESULT hr;
	LPDIRECTSOUNDBUFFER pDSB;
	hr = m_pDSound->DuplicateSoundBuffer( pInfo2->pDSoundBuffer, &pDSB );
	if ( FAILED( hr ) ) {
		ErrLog( "CDSoundManager::Duplicate() : DuplicateSoundBuffer()\n"
				"		%s", DXGetErrorString9( hr ) );
		return false;
	}

	// DirectSoundBuffer8 ̍쐬
	hr = pDSB->QueryInterface( IID_IDirectSoundBuffer8,
				( LPVOID* ) &( pInfo1->pDSoundBuffer ) );
	if ( FAILED( hr ) ) {
		RELEASE( pDSB );
		Delete( obj1 );
		ErrLog( "CDSoundManager::Duplicate() : QueryInterface() DirectSoundBuffer8\n"
				"		%s", DXGetErrorString9( hr ) );
		return false;
	}

	if ( bSound3D ) {
		// DirectSound3DBuffer8 ̍쐬
		hr = pDSB->QueryInterface( IID_IDirectSound3DBuffer8,
								   (LPVOID*) &( pInfo1->pDSound3DBuffer ) );
		if ( FAILED( hr ) ) {
			RELEASE( pDSB );
			Delete( obj1 );
			ErrLog( "CDSoundManager::Duplicate() : QueryInterface() DirectSound3DBuffer8\n"
					"		%s", DXGetErrorString9( hr ) );
			return false;
		}
	}

	RELEASE( pDSB );
	return true;
}

//-----------------------------------------------------------------------------
// Name : Play()
// Desc : TEh̍Đ
// Argu : obj = SNDOBJ IuWFNg
//-----------------------------------------------------------------------------
bool CDSoundManager::Play( SNDOBJ obj, bool loop )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	static HRESULT hr;
	hr = pInfo->pDSoundBuffer->Play( 0, 0, ( DWORD ) loop );
	if ( FAILED( hr ) ) {
		ErrLog( "CDSoundManager::Play() : Play()\n"
				"		%s", DXGetErrorString9( hr ) );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : Stop()
// Desc : TEh̒~
// Argu : obj = SNDOBJ IuWFNg
//-----------------------------------------------------------------------------
bool CDSoundManager::Stop( SNDOBJ obj )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	pInfo->pDSoundBuffer->Stop();
	pInfo->pDSoundBuffer->SetCurrentPosition( 0 );

	return true;
}

//-----------------------------------------------------------------------------
// Name : StopAll()
// Desc : ׂẴTEh̒~
//-----------------------------------------------------------------------------
void CDSoundManager::StopAll()
{
	static int size;
	m_vInfo.GetSize( size );
	static SNDOBJ obj;

	for ( int i = 0; i < size; i++ ) {
		obj.n = i;
		Stop( obj );
	}
}

//-----------------------------------------------------------------------------
// Name : Pause()
// Desc : TEḧꎞ~
// Argu : obj = SNDOBJ IuWFNg
//-----------------------------------------------------------------------------
bool CDSoundManager::Pause( SNDOBJ obj )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	pInfo->pDSoundBuffer->Stop();

	return true;
}

//-----------------------------------------------------------------------------
// Name : IsPlaying()
// Desc : TEh̍ĐԂ̎擾
// Argu : obj = SNDOBJ IuWFNg
//-----------------------------------------------------------------------------
bool CDSoundManager::IsPlaying( SNDOBJ &obj, bool IsLoop )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	static HRESULT hr;
	static DWORD dwState;
	hr = pInfo->pDSoundBuffer->GetStatus( &dwState );
	if ( FAILED( hr ) ) {
		ErrLog( "CDSoundManager::IsPlaying() : GetStatus()\n"
				"		%s", DXGetErrorString9( hr ) );
		return false;
	}

	if ( IsLoop ) {
		if ( ( dwState & DSBSTATUS_LOOPING ) == DSBSTATUS_LOOPING ) return true;
	}
	else {
		if ( ( dwState & DSBSTATUS_PLAYING ) == DSBSTATUS_PLAYING ) return true;
	}
	return false;
}

//-----------------------------------------------------------------------------
// Name : SetVolume()
// Desc : ʂ̐ݒ
// Argu : obj	 = SNDOBJ IuWFNg
//		  volume =  ( 0`100% )
//-----------------------------------------------------------------------------
bool CDSoundManager::SetVolume( SNDOBJ obj, int volume )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// {[̐ݒ
	if ( volume <= 0 ) volume = -10000;
	else if ( volume >= 100 ) volume = 0;
	else volume = ( int ) ( ( 20.0 * log10( volume / 100.0 ) ) * 100 );
	
	pInfo->pDSoundBuffer->SetVolume( volume );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetFrequency()
// Desc : g̐ݒ
// Argu : obj		= SNDOBJ IuWFNg
//		  frequency = g ( 100 ` 100000Hz )
//-----------------------------------------------------------------------------
bool CDSoundManager::SetFrequency( SNDOBJ obj, int frequency )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// El
	if ( frequency != 0 ) {
		if ( frequency < 100 ) frequency = 100;
		else if ( frequency > 100000 ) frequency = 100000;
	}

	// g̐ݒ
	pInfo->pDSoundBuffer->SetFrequency( frequency );

	return true;
}

//-----------------------------------------------------------------------------
// Name : GetFrequency()
// Desc : g̐ݒ
// Argu : obj		 = SNDOBJ IuWFNg
//		  rFrequency = g
//-----------------------------------------------------------------------------
bool CDSoundManager::GetFrequency( SNDOBJ obj, int &rFrequency )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// g̎擾
	pInfo->pDSoundBuffer->GetFrequency( ( DWORD* ) &rFrequency );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetPan()
// Desc : p̐ݒ
// Argu : obj	 = SNDOBJ IuWFNg
//		  pan =  ( 0`100% )
//-----------------------------------------------------------------------------
bool CDSoundManager::SetPan( SNDOBJ obj, int pan )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// 3D TEh̏ꍇ͏I
	if ( pInfo->pDSound3DBuffer ) {
		ErrLog( "CDSoundManager::SetPan()\n"
				"		2DTEhł͂Ȃ" );
		return false;
	}
	
	bool PanLeft = false;

	// `l̏ꍇAxvXlɕςČvZ
	if ( pan < 0 ) {
		PanLeft = true;
		pan *= -1;
	}
	// p̌vZ
	if ( pan >= 100 ) pan = 10000;
	else {
		pan = 100 - pan;
		pan = - ( int ) ( ( 20.0 * log10( pan / 100.0 ) ) * 100 );
	}
	// 
	if ( PanLeft ) pan *= -1;

	// p̐ݒ
	pInfo->pDSoundBuffer->SetPan( pan );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetPos()
// Desc : ʒu̐ݒ
// Argu : obj	 = SNDOBJ IuWFNg
//		  x, y, z = ̍Wʒu
//-----------------------------------------------------------------------------
bool CDSoundManager::SetPos( SNDOBJ obj, float x, float y, float z )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// 3DTEhł͂ȂꍇAI
	if ( !( pInfo->pDSound3DBuffer ) ) {
		ErrLog( "CDSoundManager::SetPan()\n"
				"		3DTEhł͂Ȃ" );
		return false;
	}

	pInfo->pDSound3DBuffer->SetPosition( x, y, z, DS3D_IMMEDIATE );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetVelocity()
// Desc : x̐ݒ
// Argu : obj	 = SNDOBJ IuWFNg
//		  x, y, z = ̑x
//-----------------------------------------------------------------------------
bool CDSoundManager::SetVelocity( SNDOBJ obj, float x, float y, float z )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// 3DTEhł͂ȂꍇAI
	if ( !( pInfo->pDSound3DBuffer ) ) {
		ErrLog( "CDSoundManager::SetVelocity()\n"
				"		3DTEhł͂Ȃ" );
		return false;
	}

	pInfo->pDSound3DBuffer->SetVelocity( x, y, z, DS3D_IMMEDIATE );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetMinDistance()
// Desc : ̍ŒZ̐ݒ
// Argu : obj = SNDOBJ IuWFNg
//		  min = ŒZ
//-----------------------------------------------------------------------------
bool CDSoundManager::SetMinDistance( SNDOBJ obj, float min )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// 3DTEhł͂ȂꍇAI
	if ( !( pInfo->pDSound3DBuffer ) ) {
		ErrLog( "CDSoundManager::SetMinDistance()\n"
				"		3DTEhł͂Ȃ" );
		return false;
	}
	
	pInfo->pDSound3DBuffer->SetMinDistance( min, DS3D_IMMEDIATE );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetMaxDistance()
// Desc : ̍Œ̐ݒ
// Argu : obj = SNDOBJ IuWFNg
//		  max = Œ
//-----------------------------------------------------------------------------
bool CDSoundManager::SetMaxDistance( SNDOBJ obj, float max )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// 3DTEhł͂ȂꍇAI
	if ( !( pInfo->pDSound3DBuffer ) ) {
		ErrLog( "CDSoundManager::SetMaxDistance()\n"
				"		3DTEhł͂Ȃ" );
		return false;
	}

	pInfo->pDSound3DBuffer->SetMaxDistance( max, DS3D_IMMEDIATE );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetConeAngle()
// Desc : R[̊px̐ݒ
// Argu : obj = SNDOBJ IuWFNg
//		  inAngle  = R[̊px
//		  outAngle = OR[̊px
//-----------------------------------------------------------------------------
bool CDSoundManager::SetConeAngle( SNDOBJ obj, int inAngle, int outAngle )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// 3DTEhł͂ȂꍇAI
	if ( !( pInfo->pDSound3DBuffer ) ) {
		ErrLog( "CDSoundManager::SetConeAngle()\n"
				"		3DTEhł͂Ȃ" );
		return false;
	}

	// Eݒ
	if( inAngle < 0 ) inAngle = 0;
	else if( inAngle > 360 ) inAngle = 360;
	if( outAngle < 0 ) outAngle = 0;
	else if( outAngle > 360 ) outAngle = 360;

	pInfo->pDSound3DBuffer->SetConeAngles( inAngle, outAngle, DS3D_IMMEDIATE );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetConeDirection()
// Desc : R[̐̕ݒ
// Argu : obj = SNDOBJ IuWFNg
//		  x, y, z = 
//-----------------------------------------------------------------------------
bool CDSoundManager::SetConeDirection( SNDOBJ obj, float x, float y, float z )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// 3DTEhł͂ȂꍇAI
	if ( !( pInfo->pDSound3DBuffer ) ) {
		ErrLog( "CDSoundManager::SetConeDirection()\n"
				"		3DTEhł͂Ȃ" );
		return false;
	}

	pInfo->pDSound3DBuffer->SetConeOrientation( x, y, z, DS3D_IMMEDIATE );

	return true;
}

//-----------------------------------------------------------------------------
// Name : SetConeOutsideVolume()
// Desc : OR[̉ʂ̐ݒ
// Argu : obj = SNDOBJ IuWFNg
//		  volume = 
//-----------------------------------------------------------------------------
bool CDSoundManager::SetConeOutsideVolume( SNDOBJ obj, int volume )
{
	static SOUND_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// 3DTEhł͂ȂꍇAI
	if ( !( pInfo->pDSound3DBuffer ) ) {
		ErrLog( "CDSoundManager::SetConeDirection()\n"
				"		3DTEhł͂Ȃ" );
		return false;
	}
	
	pInfo->pDSound3DBuffer->SetConeOutsideVolume( volume, DS3D_IMMEDIATE );

	return true;
}
