#include "../Include/AppSystem.h"

//-----------------------------------------------------------------------------
// Name : CSoundReader()
//-----------------------------------------------------------------------------
CSoundReader::CSoundReader()
{
	m_hmmio		= 0;
	m_WaveSize	= 0;
	m_pWaveData = 0;
}

//-----------------------------------------------------------------------------
// Name : ~CSoundReader()
//-----------------------------------------------------------------------------
CSoundReader::~CSoundReader()
{
	SAFE_FREE( m_pWaveData );
	mmioClose( m_hmmio, 0 );
	m_hmmio = 0;
}

//-----------------------------------------------------------------------------
// Name : WaveOpen()
// Desc : TEht@CJ
// Argu : filename = t@C
//-----------------------------------------------------------------------------
bool CSoundReader::WaveOpen( char *filename )
{
	MMRESULT mmres;
	//	t@C̃I[v
	m_hmmio = mmioOpen( filename, 0, MMIO_READ );
	if ( m_hmmio == 0 ) return false;

	//	WAVE`Nɂ
	m_mmckinfoWave.fccType = mmioFOURCC( 'W','A','V','E' );
	mmres = mmioDescend( m_hmmio, ( LPMMCKINFO ) &m_mmckinfoWave, 0, MMIO_FINDRIFF );
	if ( mmres == MMIOERR_CHUNKNOTFOUND ) {
		mmioClose( m_hmmio, 0 );
		return false;
	}
	//	fmt`Nɂ
	m_mmckinfoSub.ckid = mmioFOURCC( 'f','m','t',' ' );
	mmres = mmioDescend( m_hmmio, &m_mmckinfoSub, &m_mmckinfoWave, MMIO_FINDCHUNK );
	if ( mmres == MMIOERR_CHUNKNOTFOUND ) {
		mmioClose( m_hmmio, 0 );
		return false;
	}
	//	fmt`NAWavetH[}bg擾
	if ( mmioRead( m_hmmio, ( HPSTR ) &m_wfx, m_mmckinfoSub.cksize ) 
		!= ( LONG ) m_mmckinfoSub.cksize ) {
			mmioClose( m_hmmio, 0 );
			return false;
	}

	//	WAVE`Nɖ߂
	mmioAscend( m_hmmio, &m_mmckinfoSub, 0 );

	//	data`Nɂ
	m_mmckinfoSub.ckid = mmioFOURCC( 'd','a','t','a' );
	mmres = mmioDescend( m_hmmio, &m_mmckinfoSub, &m_mmckinfoWave, MMIO_FINDCHUNK );
	if ( mmres == MMIOERR_CHUNKNOTFOUND ){
		mmioClose( m_hmmio, 0 );
		return false;
	}
	//	f[^擾
	m_WaveSize = m_mmckinfoSub.cksize;

	return true;
}

//-----------------------------------------------------------------------------
// Name : WaveRead()
// Desc : TEhETCY̎擾
//-----------------------------------------------------------------------------
bool CSoundReader::WaveRead( DWORD WaveSize )
{
	if ( WaveSize <= 0 ) WaveSize = m_WaveSize;

	// w肵oCg̃mۂ
	m_pWaveData = ( DWORD* ) malloc( m_WaveSize );

	if ( ( DWORD ) mmioRead( m_hmmio, ( HPSTR ) m_pWaveData, m_WaveSize ) 
		!= m_WaveSize ) {
		SAFE_FREE( m_pWaveData );
		mmioClose( m_hmmio, 0 );
		return false;
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name : OggOpen()
// Desc : OggVorbis t@CJ
//-----------------------------------------------------------------------------
bool CSoundReader::OggOpen( char *filename )
{	
	// t@CJ
	FILE *fpt = fopen( filename, "rb" );
	if ( fpt == 0 ) return false;

	// Ogg t@CJ
	if ( ov_open( fpt, &m_OggFile, 0, 0 ) < 0 ) {
		fclose( fpt );
		return false;
	}

	// t@C̏擾
	vorbis_info *OggInfo;
	OggInfo = ov_info( &m_OggFile, -1 );

	// Wave wb_TCY߂
	WAVEFILE_HEADER wh;
	ZeroMemory( &wh, sizeof( WAVEFILE_HEADER ) );
	m_HeaderSize =  sizeof( wh.cData )		+ sizeof( wh.cFmt ) +
					sizeof( wh.cRIFF )		+ sizeof( wh.cType ) + 
					sizeof( wh.iSizeData )	+ sizeof( wh.iSizeFmt ) + 
					sizeof( wh.iSizeRIFF )	+ sizeof( m_wfx ); 

	m_iWord = 2;  // ʎqoCg( 1 or 2 )

	// f[^TCY
	m_DataSize = ( LONG ) ceil( OggInfo->channels * OggInfo->rate * 
		ov_time_total( &m_OggFile, -1 ) * m_iWord );

	// fR[h̃f[^TCY
	m_WaveSize = m_HeaderSize + m_DataSize;

	// tH[}bg
	m_wfx.cbSize			= sizeof( WAVEFORMATEX );
	m_wfx.wFormatTag		= WAVE_FORMAT_PCM;
	m_wfx.nChannels			= OggInfo->channels;
	m_wfx.nSamplesPerSec	= OggInfo->rate;
	m_wfx.nAvgBytesPerSec	= OggInfo->rate * OggInfo->channels * m_iWord;
	m_wfx.nBlockAlign		= OggInfo->channels * m_iWord;
	m_wfx.wBitsPerSample	= m_iWord * 8;

	return true;
}

//-----------------------------------------------------------------------------
// Name : OggRead()
// Desc : OggVorbis t@Cǂݍ
//-----------------------------------------------------------------------------
bool CSoundReader::OggRead( DWORD WaveSize )
{
	if ( WaveSize <= 0 ) WaveSize = m_WaveSize;

	// w肵oCg̃mۂ
	m_pWaveData = ( DWORD* ) malloc( m_WaveSize );
	if ( m_pWaveData == 0 ) {
		ov_clear( &m_OggFile );
		return false;
	}

	// fR[h
	INT  iCurrentSection;
	LONG lWriteSize;
	LONG lReadSize = 0;

	while ( 1 ) {
		// ǂݍ
		lWriteSize = ov_read( 
			&m_OggFile, ( char* )m_pWaveData + lReadSize + m_HeaderSize,
			m_DataSize - lReadSize, 0, m_iWord, 1, &iCurrentSection );
		// fR[hI
		if ( lWriteSize == 0 ) break;
		// G[
		else if ( lWriteSize < 0 ) {
			SAFE_FREE( m_pWaveData );
			ov_clear( &m_OggFile );
			return false;
		}
		// ׂăfR[hłȂ
		else {
			lReadSize += lWriteSize;
		}
	}

	// wb_̏
	WAVEFILE_HEADER wh;
	memcpy( wh.cRIFF, "RIFF", 4 );
	wh.iSizeRIFF = m_HeaderSize + lReadSize - 8;
	memcpy( wh.cType, "WAVE", 4 );
	memcpy( wh.cFmt, "fmt ", 4 );
	wh.iSizeFmt = sizeof( WAVEFORMATEX );
	memcpy( wh.cData, "data", 4 );
	wh.iSizeData = lReadSize;

	// wb_̏
	int iSize = 0;
	memcpy( m_pWaveData,		 &wh.cRIFF,		sizeof( wh.cRIFF ) );
	iSize += sizeof( wh.cRIFF );
	memcpy( m_pWaveData + iSize, &wh.iSizeRIFF,	sizeof( wh.iSizeRIFF ) );
	iSize += sizeof( wh.iSizeRIFF );
	memcpy( m_pWaveData + iSize, &wh.cType,		sizeof( wh.cType ) );
	iSize += sizeof( wh.cType );
	memcpy( m_pWaveData + iSize, &wh.cFmt,		sizeof( wh.cFmt ) );
	iSize += sizeof( wh.cFmt );
	memcpy( m_pWaveData + iSize, &wh.iSizeFmt,	sizeof( wh.iSizeFmt ) );
	iSize += sizeof( wh.iSizeFmt );
	memcpy( m_pWaveData + iSize, &m_wfx,		sizeof( m_wfx ) );
	iSize += sizeof( m_wfx );
	memcpy( m_pWaveData + iSize, &wh.cData,		sizeof( wh.cData ) );
	iSize += sizeof( wh.cData );
	memcpy( m_pWaveData + iSize, &wh.iSizeData,	sizeof( wh.iSizeData ) );

	ov_clear( &m_OggFile );

	return true;
}

//-----------------------------------------------------------------------------
// Name : GetSize()
// Desc : TEhETCY̎擾
//-----------------------------------------------------------------------------
DWORD CSoundReader::GetSize()
{
	return m_WaveSize;
}

//-----------------------------------------------------------------------------
// Name : GetFormat()
// Desc : TEhEtH[}bg̎擾
//-----------------------------------------------------------------------------
WAVEFORMATEX CSoundReader::GetFormat()
{
	return m_wfx;
}

//-----------------------------------------------------------------------------
// Name : GetpData()
// Desc : TEhEf[^̎擾
//-----------------------------------------------------------------------------
DWORD* CSoundReader::GetpData()
{
	return m_pWaveData;
}