#include "../Include/AppSystem.h"

//-----------------------------------------------------------------------------
// Name : TEXTURE_INFO()
//-----------------------------------------------------------------------------
TEXTURE_INFO::TEXTURE_INFO()
{
	pTexture = 0;
}

//-----------------------------------------------------------------------------
// Name : ~TEXTURE_INFO()
//-----------------------------------------------------------------------------
TEXTURE_INFO::~TEXTURE_INFO()
{
	RELEASE( pTexture );
}

//-----------------------------------------------------------------------------
// Name : Check
// Desc : eNX`̃`FbN
//-----------------------------------------------------------------------------
bool CTextureManager::Check( TEXOBJ obj )
{
	return m_vInfo.Check( obj );
}

//-----------------------------------------------------------------------------
// Name : Create()
// Desc : eNX`̍쐬
// Argu : obj = eNX`EIuWFNg
//-----------------------------------------------------------------------------
bool CTextureManager::Create( TEXOBJ &obj, const char *filename, D3DCOLOR ColorKey )
{
	m_vInfo.Create( obj );

	static TEXTURE_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	// eNX`̍쐬
	HRESULT hr = D3DXCreateTextureFromFileEx( 
			d3d.m_pD3DDev, filename, 0, 0, 0, 0, D3DFMT_UNKNOWN, 
			D3DPOOL_MANAGED, D3DX_FILTER_NONE, D3DX_DEFAULT, ColorKey,
			&( pInfo->ImageInfo ), 0, &( pInfo->pTexture ) );
	if ( FAILED( hr ) ) {
		ErrLog( "CTextureManager::Create() D3DXCreateTextureFromFileEx()\n"
			    "		%s\n"
				"		%s", filename, DXGetErrorString9( hr ) );
		MesBox( "G[", "%s ̓ǂݍ݂Ɏs܂", filename );
		m_vInfo.Delete( obj );
		return false;
	}

	// eNX`ETCY̎擾
	D3DSURFACE_DESC desc;
	pInfo->pTexture->GetLevelDesc( 0, &desc );
	pInfo->TextureSize.cx = desc.Width;
	pInfo->TextureSize.cy = desc.Height;

	return true;
}

//-----------------------------------------------------------------------------
// Name : Duplicate()
// Desc : eNX`̕
// Argu : obj1 = ̃eNX`EIuWFNg
//		  obj2 = ̃eNX`EIuWFNg
//-----------------------------------------------------------------------------
bool CTextureManager::Duplicate( TEXOBJ &dest, TEXOBJ source )
{
	// ƕ悪ꍇAI
	if ( dest == source ) return true;

	static TEXTURE_INFO *pSourceInfo;
	pSourceInfo = m_vInfo.GetpObject( source );
	if ( pSourceInfo == 0 ) return false;

	// IuWFNg̍쐬
	m_vInfo.Create( dest );

	static TEXTURE_INFO *pDestInfo;
	pDestInfo = m_vInfo.GetpObject( dest );
	if ( pDestInfo == 0 ) return false;

	// eNX`̃Rs[
	pDestInfo->pTexture		=  pSourceInfo->pTexture;
	pDestInfo->pTexture->AddRef();	// QƃJE^𑝂₷
	// 摜̃Rs[
	pDestInfo->ImageInfo	= pSourceInfo->ImageInfo;
	pDestInfo->TextureSize	= pSourceInfo->TextureSize;

	return true;
}

//-----------------------------------------------------------------------------
// Name : Delete()
// Desc : eNX`̍폜
// Argu : obj = eNX`EIuWFNg
//-----------------------------------------------------------------------------
bool CTextureManager::Delete( TEXOBJ &obj )
{
	if ( m_vInfo.Delete( obj ) ) return true;
	return false;
}

//-----------------------------------------------------------------------------
// Name : GetImageSize()
// Desc : 摜TCY̎擾
// Argu : *x = 擾TCY
//		: *y = 擾cTCY
//		: obj = 擾eNX`EIuWFNg
//-----------------------------------------------------------------------------
bool CTextureManager::GetImageSize( SIZE &rSize, TEXOBJ obj )
{
	static TEXTURE_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	rSize.cx = pInfo->ImageInfo.Width;
	rSize.cy = pInfo->ImageInfo.Height;

	return true;
}

//-----------------------------------------------------------------------------
// Name : GetTextureSize()
// Desc : eNX`ETCY̎擾
// Argu : *x = 擾TCY
//		: *y = 擾cTCY
//		: obj = 擾eNX`EIuWFNg
//-----------------------------------------------------------------------------
bool CTextureManager::GetTextureSize( SIZE &rSize, TEXOBJ obj )
{
	static TEXTURE_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	rSize = pInfo->TextureSize;

	return true;
}

//-----------------------------------------------------------------------------
// Name : GetpTexture()
// Desc : eNX`̎擾
// Argu : *m_pTexture = 擾eNX`
//		: obj = 擾eNX`EIuWFNg
//-----------------------------------------------------------------------------
LPDIRECT3DTEXTURE9 CTextureManager::GetpTexture( TEXOBJ obj )
{
	static TEXTURE_INFO *pInfo;
	pInfo = m_vInfo.GetpObject( obj );
	if ( pInfo == 0 ) return false;

	return pInfo->pTexture;
}

//-----------------------------------------------------------------------------
// Name : SetFilter()
// Desc : tB^[̐ݒ
// Argu : mode = tB^[̎
//-----------------------------------------------------------------------------
void CTextureManager::SetFilter( FILTER_MODE mode )
{
	d3d.m_pD3DDev->SetSamplerState( 0, D3DSAMP_MINFILTER, mode );
	d3d.m_pD3DDev->SetSamplerState( 0, D3DSAMP_MAGFILTER, mode );
}